GNU bug report logs - #24201
25.1.50; TLS connections sometimes hang

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Lars Ingebrigtsen <larsi@HIDDEN>; Keywords: fixed; Done: Lars Ingebrigtsen <larsi@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug marked as fixed in version 28.1, send any further explanations to 24201 <at> debbugs.gnu.org and Lars Ingebrigtsen <larsi@HIDDEN> Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 3 Aug 2020 06:00:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Aug 03 02:00:36 2020
Received: from localhost ([127.0.0.1]:43897 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k2TWW-00005q-33
	for submit <at> debbugs.gnu.org; Mon, 03 Aug 2020 02:00:36 -0400
Received: from quimby.gnus.org ([95.216.78.240]:40930)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1k2TWU-0008RB-T9
 for 24201 <at> debbugs.gnu.org; Mon, 03 Aug 2020 02:00:35 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=fG46xmTApmbdUyIle+8Cuw5iB7NRdqS6+7N4CTm38qU=; b=oGHyKpgYjPD/jATGS0e3FpyltM
 b0BBq5gZvnUAsbtj3lP0BfVhStGLEd7MLc325uEc40ucAiCGwOaaa4lWd2Li7ONr3CmagWbj5qWmh
 RhRHIigcgOougsQbMkHOULJ2DdIIE1IDkZhQW83D3uH9H/CsWsSfgfNiU/668j1WN9HE=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1k2TWL-0004pi-OA; Mon, 03 Aug 2020 08:00:29 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83h8qc92hc.fsf@HIDDEN> <m3woz8d89h.fsf@HIDDEN>
 <m3blynxggv.fsf@HIDDEN> <834l4en63b.fsf@HIDDEN>
 <m3y31qn246.fsf@HIDDEN> <m38stpzdbu.fsf@HIDDEN>
 <m3o92luy40.fsf@HIDDEN> <83h88cjoiv.fsf@HIDDEN>
 <m3ftnvtiyz.fsf@HIDDEN> <87ftntkc53.fsf@HIDDEN>
 <83sgrthih6.fsf@HIDDEN> <m3o92eyjzj.fsf@HIDDEN>
 <m3a7du7xxl.fsf@HIDDEN> <835zohboyc.fsf@HIDDEN>
 <m3muhsiqlz.fsf@HIDDEN> <83muhs9x5i.fsf@HIDDEN>
 <m3lfxbgxz2.fsf@HIDDEN> <m3a7dpn26e.fsf@HIDDEN>
 <83pnml7lo2.fsf@HIDDEN> <m3r2701nxs.fsf@HIDDEN>
Date: Mon, 03 Aug 2020 08:00:24 +0200
In-Reply-To: <m3r2701nxs.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Mon,
 08 Jul 2019 18:38:39 +0200")
Message-ID: <87y2mwe0av.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  This was now apparently fixed by bug#40665 -- at least, I
 haven't seen a single of these hangs after running with that patch for a day.
 So I'm closing this bug report. -- (domestic pets only, the antidote for
 overdose, milk.) bloggy blog: http://lars.ingebrigtsen.no 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

This was now apparently fixed by bug#40665 -- at least, I haven't seen a
single of these hangs after running with that patch for a day.

So I'm closing this bug report.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 8 Jul 2019 16:38:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 12:38:45 2019
Received: from localhost ([127.0.0.1]:59387 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkWf7-00031K-BU
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 12:38:45 -0400
Received: from quimby.gnus.org ([80.91.231.51]:58510)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hkWf5-000317-EW
 for 24201 <at> debbugs.gnu.org; Mon, 08 Jul 2019 12:38:43 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hkWf1-0003Ml-FO; Mon, 08 Jul 2019 18:38:41 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
 <835zohboyc.fsf@HIDDEN> <m3muhsiqlz.fsf@HIDDEN>
 <83muhs9x5i.fsf@HIDDEN> <m3lfxbgxz2.fsf@HIDDEN>
 <m3a7dpn26e.fsf@HIDDEN> <83pnml7lo2.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAGFBMVEUCDDPo6NwQG0ALFTsA
 Bi3+/u4GEDY+R2UazpW6AAACZklEQVQ4jYWUQW/bMAyFCTlQzj0IuXpUZ181qVCuxmLk7oPhq2IX
 6rVzmunv70lxtw4bNgaGDH0mH8lQoodhUOMw/mGk/tz7D3hQGX3Aw/2dmLlNKT3AxuGQDqmYGqnP
 tuuqGPfjtOs3+7yBYl/H6Smvkvb+d6Am5/t9wuv500hdiPE5xFOIs5qO6bF9eez77ksGPhLgBt5S
 egO4jHTW1lpttbazGub18bpu4KPGYNmIFqmdEerEPLN2FosazHN3TLwroFuiW5bFOWcBeseJeScR
 qotxwQ+WPSTbdLVPFdI9QxptwQOPWnznlrmWCNVTsR1JAVA1dmVuMjizZfhoLADGaG64yhpnSDu7
 aOetmsyTEfzKp03cOY+sFoAmaAFf2VxKqDULwtTExPPKwmiAEwpAo0q6E1dNvLJ4nS+l8pyry+lm
 EFamq8gaqMNtWR1YNIGbijkDHzeDBz4Irq5YbHVwebJ4srqx87Et6cq7QwXxNrkgAh3TReVeZXnH
 1qqDrT0JQ41+GUliV5fEIO6pocWQkceRKJZYstRhgiG/gRP/NLSEsGsoZtDdpcO9V1STDxSpLVOC
 At1dI4OAaaJjqcOWOnQJVUuTwYuijqSUIbcR4hq6MSIUwPld2ubKo8FH+KePahP3Po/PpGUtKYea
 4eFcg3lz7Fz2qKtfwOp7D7UaWCNOQCiAvoN+Hh+SAGxFTdYUj/vwoI76NvB+5dC5uRbwiKH0ffHx
 NmixdvCvwpKBlNFXfvHhNukYUBAiO1XOhw8aUnQbXsu45gOq6DmfReZyuIf0LW2mKJ/893vh4/Xx
 r7vk7+AHYDoITYamAOAAAAAASUVORK5CYII=
Date: Mon, 08 Jul 2019 18:38:39 +0200
In-Reply-To: <83pnml7lo2.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 07 Jul
 2019 21:18:53 +0300")
Message-ID: <m3r2701nxs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > Maybe add only one
 fprintf (assuming doing that doesn't make the > problem go away), then move
 it around to see the control flow. It's > less convenient and more
 time-consuming, but maybe there's no [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Maybe add only one fprintf (assuming doing that doesn't make the
> problem go away), then move it around to see the control flow.  It's
> less convenient and more time-consuming, but maybe there's no better
> alternative.

Yup; I'll try different things to see if I can get it to break more
reliably...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 7 Jul 2019 18:19:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 07 14:19:13 2019
Received: from localhost ([127.0.0.1]:57389 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkBkn-0003ba-KM
	for submit <at> debbugs.gnu.org; Sun, 07 Jul 2019 14:19:13 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50910)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hkBkk-0003bK-KT
 for 24201 <at> debbugs.gnu.org; Sun, 07 Jul 2019 14:19:12 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43752)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hkBka-0005uW-GW; Sun, 07 Jul 2019 14:19:03 -0400
Received: from [176.228.60.248] (port=2188 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hkBkY-00021J-BI; Sun, 07 Jul 2019 14:18:59 -0400
Date: Sun, 07 Jul 2019 21:18:53 +0300
Message-Id: <83pnml7lo2.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3a7dpn26e.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 07 Jul 2019 20:13:13 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
 <835zohboyc.fsf@HIDDEN> <m3muhsiqlz.fsf@HIDDEN>
 <83muhs9x5i.fsf@HIDDEN> <m3lfxbgxz2.fsf@HIDDEN> <m3a7dpn26e.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org
> Date: Sun, 07 Jul 2019 20:13:13 +0200
> 
> Lars Ingebrigtsen <larsi@HIDDEN> writes:
> 
> > I'll add some instrumentation to that function now and try to figure out
> > why it's not heeding the timeout.  It's so annoying that I haven't been
> > able to make a simple test case to reproduce the error, though, because
> > the hang only happens once every few hours...
> 
> Amusingly enough, after adding some fprintfs to the function, I haven't
> seen a single hang.  :-/

Maybe add only one fprintf (assuming doing that doesn't make the
problem go away), then move it around to see the control flow.  It's
less convenient and more time-consuming, but maybe there's no better
alternative.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 7 Jul 2019 18:13:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 07 14:13:22 2019
Received: from localhost ([127.0.0.1]:57383 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkBf7-0003S7-UH
	for submit <at> debbugs.gnu.org; Sun, 07 Jul 2019 14:13:22 -0400
Received: from quimby.gnus.org ([80.91.231.51]:43240)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hkBf5-0003Ry-N5
 for 24201 <at> debbugs.gnu.org; Sun, 07 Jul 2019 14:13:20 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hkBez-0000w6-B3; Sun, 07 Jul 2019 20:13:17 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
 <835zohboyc.fsf@HIDDEN> <m3muhsiqlz.fsf@HIDDEN>
 <83muhs9x5i.fsf@HIDDEN> <m3lfxbgxz2.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAGFBMVEU6NjgGAgQfCg9oY2Mg
 Bguln5zk4N0bGBvE1LWcAAACc0lEQVQ4jWWTTY+bMBCGhxrqa8xuxXVDVXGFjhyupMoPQLLGe42E
 7LMTFPnvd2zIVkrnRObxfL0zgZjt3sXu3sYAMG6OCDG2bCrbAW/tWijVqroFdVRPi+KmVDNuP0D9
 s7ln0K3HV3AwDG5dGF5BNc/8uAn9CzhY+twqvYA3r0furvkPKG1kc1MB1g3Er3YPlSnubei3twAg
 d9Y8aKhvHewAEbUp8vcPNxzV/fBzB9p6lyZLg7BQsvm4bYC890bmbMO3Lsiwygw0+x1hJoOWIAXN
 KTNYBmQQ07NhjYCCxlQefMqESInIWgUU+HvdAXFj5KlQb2P7waD4VWTgTOrM+6tqBpZQ9LfHUiSw
 +/2iVtMJCPJeOSzAu93vl+g9iB4gokMDDnHzO1Nx3z0gq3RChKefOzslGgF0L1CwJD5Pwk/zSBLA
 cQPrNrlJ8fmTZqgIQWKanJKbj22LBeu4gRko8Xx7QWSgHaetUhPxaRzN8Rwghe7ZnUTuMjl5ctYv
 EJB7aLe9ZnJyLJlfgkCKzyuptwhvrZ1B6OUL8D1l4ImHB206eL9c1DPZyTvrTABhrw2D6StZxQFu
 hErba0zgcjk/gUFeLGk7ZjDBDk68AjLakJMJcMhUTucmBrtoTWi0d6xxiijL8nKu48otkZt5cUtE
 BgBlTtY9eCtkjSB7DQTv+f2UwPoE/nNlABNA8vMgFafSM4MRKdUoc78tywu09LOwHnZQ8vB1F4Ns
 g+u59hX4ShL4k5UKpudRjNB+Bo2pxnSps+rfHUrt+CbmgLnd8yZ6PBCNwmi+B6gcy37Jmgd5PB6E
 5HPiP1/PxfdlBJDbX4+3gcn+Ah5I8zTu6ecSAAAAAElFTkSuQmCC
Date: Sun, 07 Jul 2019 20:13:13 +0200
In-Reply-To: <m3lfxbgxz2.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 06 Jul 2019 14:16:01 +0200")
Message-ID: <m3a7dpn26e.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Lars Ingebrigtsen <larsi@HIDDEN> writes: > I'll add some
 instrumentation to that function now and try to figure out > why it's not
 heeding the timeout. It's so annoying that I haven't been > able to make
 a simple test case to reproduce the e [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> I'll add some instrumentation to that function now and try to figure out
> why it's not heeding the timeout.  It's so annoying that I haven't been
> able to make a simple test case to reproduce the error, though, because
> the hang only happens once every few hours...

Amusingly enough, after adding some fprintfs to the function, I haven't
seen a single hang.  :-/

So this is even more timing dependent than I imagined, and I'll have to
instrument this in a different way, I guess...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 6 Jul 2019 12:16:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 06 08:16:09 2019
Received: from localhost ([127.0.0.1]:54333 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hjjbs-0003qC-If
	for submit <at> debbugs.gnu.org; Sat, 06 Jul 2019 08:16:08 -0400
Received: from quimby.gnus.org ([80.91.231.51]:51666)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hjjbq-0003oI-OD
 for 24201 <at> debbugs.gnu.org; Sat, 06 Jul 2019 08:16:07 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hjjbm-0004OD-12; Sat, 06 Jul 2019 14:16:04 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
 <835zohboyc.fsf@HIDDEN> <m3muhsiqlz.fsf@HIDDEN>
 <83muhs9x5i.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAElBMVEXSSAvtrQn64gfliQpM
 AAFlAQX8KfDUAAACYklEQVQ4jVWUTZLcIAyFhTW9t+ACBi4gocx+qmLvnerx/a+SJ9ydqWjRdvPx
 kNCP6Zp2UhIpTo/5b4fR9b3vx8m5wUSUAnwHiJ+LZWutVM9FsXAEoVgnH320msXiNCxcExwnuayt
 FnfDWS9JAO1SuOYq3UyJP6cE4FQS8p4LTjIp5FNC++FKzb1KNbHUE/EvSAB+u5bk0nM3aMzVFcdf
 tLOze7Eq3n0rvGix74j0gL9F3bqP5mI1E2mcRV+FaDHGDVovvoqyF8R10FcnN0+CgEZei5Grxq3p
 +WCp/ClVJMvwwU3dIyVP7MbV/kQW64JEFskagIs1RPRpUIyCpEjN6wQiHvYw8Yqw3LP0jwkGkgfX
 ynd+JbeCDFOybD1Xa3BSM2qFN5ug1DwQUJs1BJDWUgDWUqGWdlu8txFgSVY0bW9Fym1tPBVMRIMS
 LSttJInSSstUrDQSUQqujFde1xts2G1EnFd62/SRlFmdCUVxfaLkjj0TxJbHeZ50nmjI+SYByBBO
 bnkmsbUuKJhOUMfM68i9Ztu2Vp3rBHzfbXndj3jUHp14ogIe/cCoqduKHu7bGWCprb/yAdUW7rZQ
 EEB9gxx7ZNGoB6XaXnkKhSCuRhMwVsYNRhuoc88xNHRS+6cYIaq9z/b5ovw/kBL32+mgpf3YyK3q
 HD/anyHBrdE2MynI/h4tGnMzV2YCelUuHzc4SDGDcZka48wlXKPbMWooQZRhGp7XDTBwUdTXsqk+
 wjUm6jr2WJptGqM5PxUYWzyvYxJDG4XwFgBcByr6Y7eHCebH5+WDHvdBb4AnDuOXgyMW/gKo5ab4
 Ov9kXgAAAABJRU5ErkJggg==
Date: Sat, 06 Jul 2019 14:16:01 +0200
In-Reply-To: <83muhs9x5i.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 05 Jul
 2019 21:03:21 +0300")
Message-ID: <m3lfxbgxz2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> Yes, normally when
 this code is triggered by the timer, there's other >> networking happening
 more or less at the same time. > > So maybe another process steals the
 response?
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: contovob@HIDDEN, 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Yes, normally when this code is triggered by the timer, there's other
>> networking happening more or less at the same time.
>
> So maybe another process steals the response?

That's possible...

>> That's not what the doc string says, I think?
>> 
>> --
>> Optional second argument SECONDS and third argument MILLISEC
>> specify a timeout; return after that much time even if there is
>> no subprocess output.
>> --
>> 
>> "even if"...  
>
> But if output is available, accept-process-output will return
> immediately, so "even if" really means "if".

Yeah, that's true.  But it should, in an case, not keep spinning (much)
longer than the timeout, whether there's any output or not...

>> Without the JUST-THIS-ONE parameter, accept-process-output seems to loop
>> until the peer closes the connection.  And then control is returned to
>> Lisp world and the data is in the buffer.
>
> Since you are saying that the remote does respond, this would mean the
> responses get lost somehow, or are consumed by other filter functions.
> The question is how can that happen?

What I'm seeing happening if I instrument the loop in the Lisp part with:

	(while (and (memq (process-status stream) '(open run))
		    (not (re-search-forward end-of-command nil t)))
          (push (buffer-string) my-output-list)
	  (accept-process-output stream 0.05)
	  (goto-char start))

is that when Emacs hangs, and I `C-g' after half a minute, I will get 1
"" (empty string) entry in that list, so the timeout isn't heeded.
But -- in the buffer where this is happening, the data this is waiting
for is present, so Emacs got the response and put it into the buffer --
but then just kept on spinning in wait_reading_process_output,
apparently.

I'll add some instrumentation to that function now and try to figure out
why it's not heeding the timeout.  It's so annoying that I haven't been
able to make a simple test case to reproduce the error, though, because
the hang only happens once every few hours...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 5 Jul 2019 18:03:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 05 14:03:40 2019
Received: from localhost ([127.0.0.1]:53698 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hjSYd-0002DF-KI
	for submit <at> debbugs.gnu.org; Fri, 05 Jul 2019 14:03:39 -0400
Received: from eggs.gnu.org ([209.51.188.92]:52157)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hjSYa-0002Cx-ES
 for 24201 <at> debbugs.gnu.org; Fri, 05 Jul 2019 14:03:39 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39098)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hjSYU-00021i-Oy; Fri, 05 Jul 2019 14:03:30 -0400
Received: from [176.228.60.248] (port=1729 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hjSYT-0007Sz-Mt; Fri, 05 Jul 2019 14:03:30 -0400
Date: Fri, 05 Jul 2019 21:03:21 +0300
Message-Id: <83muhs9x5i.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3muhsiqlz.fsf@HIDDEN> (message from Lars Ingebrigtsen on Fri, 
 05 Jul 2019 14:59:52 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
 <835zohboyc.fsf@HIDDEN> <m3muhsiqlz.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: contovob@HIDDEN, 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: contovob@HIDDEN,  24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Fri, 05 Jul 2019 14:59:52 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> >> -	  (accept-process-output stream 0.05)
> >> +	  (accept-process-output stream 0.05 nil t)
> >>  	  (goto-char start))
> >>  	;; Return the data we got back, or nil if the process died.
> >>  	(unless (= start (point))
> >
> > Does this mean you have other process objects active at that time?
> 
> Yes, normally when this code is triggered by the timer, there's other
> networking happening more or less at the same time.

So maybe another process steals the response?

> >> It's the JUST-THIS-ONE parameter: If that's non-nil, then
> >> accept-process-output returns after the timeout...  and we get the data.
> >
> > I don't understand: accept-process-output is supposed to hit the
> > timeout only when there's no data. 
> 
> That's not what the doc string says, I think?
> 
> --
> Optional second argument SECONDS and third argument MILLISEC
> specify a timeout; return after that much time even if there is
> no subprocess output.
> --
> 
> "even if"...  

But if output is available, accept-process-output will return
immediately, so "even if" really means "if".

> Without the JUST-THIS-ONE parameter, accept-process-output seems to loop
> until the peer closes the connection.  And then control is returned to
> Lisp world and the data is in the buffer.

Since you are saying that the remote does respond, this would mean the
responses get lost somehow, or are consumed by other filter functions.
The question is how can that happen?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 5 Jul 2019 13:13:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 05 09:13:25 2019
Received: from localhost ([127.0.0.1]:52509 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hjO1k-0000mY-Pr
	for submit <at> debbugs.gnu.org; Fri, 05 Jul 2019 09:13:24 -0400
Received: from quimby.gnus.org ([80.91.231.51]:33326)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hjO1i-0000mQ-O6
 for 24201 <at> debbugs.gnu.org; Fri, 05 Jul 2019 09:13:23 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hjO1f-000884-D7; Fri, 05 Jul 2019 15:13:21 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
 <83v9wgao2o.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAIVBMVEUKDUgAAEsAAU36+ARM
 S0QAAE+ujyb//wAAAE3+/wjWxRnUA99JAAACNklEQVQ4jbXSQYvaQBQA4FFCK3sypYUcNegiPW3J
 krA5RXc6LZ5scMCjNdPZklMhxYAnIwbmuNBTb7aRCPmVfZNJXN312gdxzHy+vPG9oLvfL+JO7iE3
 DHkRhnkRFnkBEeSw8jxDFtxk6nLlIr/LFTnx5fg/YOP7SxAxRMgFsD0ti6ML4IXPa8CVY0xevSge
 R3NdbzOtcJ7DTjeSZH4Vu+HhHIYSWnCgaE+yMzAEhKwRjbpPhOI9wEysA7hZDYVOnOOpvhoyJyFw
 4BshfO1Qw6NQscZ8NBOztPdQwU9xGjSl00MFZXXRKj/TNKUTLVAwKLe+1yl0yr0HCUuMMSQtyu0+
 pXQSu0HZK9nc4WZnqEcBFE5UQ/xD36knAfhZwfERkoYhjColiG9JDR/anxORrKEJAFpomzX8WUPG
 ZtQsy/sdTwGMdGG2NRKuVvNm3/fpxlSwul/x0FKpt32fUrOC5cmIIsZMUz4qsyzr1/lUbW8c5UiH
 QBrhYXauSDdUD990tNPJSpADlDHYdE8M6QPoJ4ULNPXNznG0bzH2MJ4ATBBu+NTUnAoYY5xxMsWe
 6Gqe1zSvasCYzxmZcjaDsX4hDB1UjX4HaTAqzJmcN30f79XLoMtWz6A++ihPAbB4rUBK2Wz5ewnf
 PlVgXGPUkLtlRs9ZKGjo7SAuxgxpLeG/o+nE2akaNibQcCdys127t+/TrfO3ehMdq27qOHTng21c
 w9Mk4C8vzW18o8CCW5tzaLvMXBrXFfwDmRTVdnC3Ri4AAAAASUVORK5CYII=
Date: Fri, 05 Jul 2019 15:13:19 +0200
In-Reply-To: <83v9wgao2o.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 05 Jul
 2019 11:21:51 +0300")
Message-ID: <m3a7dsipzk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > Can you tell which
 of the various conditions cause > accept-process-output to return after a
 timeout when you apply the > patch to network-stream.el? Then we'd know for
 sure which part helps > avoid [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: contovob@HIDDEN, 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Can you tell which of the various conditions cause
> accept-process-output to return after a timeout when you apply the
> patch to network-stream.el?  Then we'd know for sure which part helps
> avoid the loop when JUST-THIS-ONE is non-nil.

No, I'll add some debugging code to the function and the try to get it
to hang to identify what makes JUST-THIS-ONE respect the timeout.

> But what I'm missing is some description of the traffic that happens
> on the wire.  Is the remote responding or isn't it, and if not, then
> do we have any idea why?

Remote is indeed responding.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 5 Jul 2019 13:00:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 05 09:00:02 2019
Received: from localhost ([127.0.0.1]:52496 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hjNon-0000Q5-MB
	for submit <at> debbugs.gnu.org; Fri, 05 Jul 2019 09:00:02 -0400
Received: from quimby.gnus.org ([80.91.231.51]:33050)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hjNol-0000PY-Sb
 for 24201 <at> debbugs.gnu.org; Fri, 05 Jul 2019 09:00:00 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hjNoe-0007ss-73; Fri, 05 Jul 2019 14:59:55 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
 <835zohboyc.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAIVBMVEUKDUgAAEsAAU36+ARM
 S0QAAE+ujyb//wAAAE3+/wjWxRnUA99JAAACNklEQVQ4jbXSQYvaQBQA4FFCK3sypYUcNegiPW3J
 krA5RXc6LZ5scMCjNdPZklMhxYAnIwbmuNBTb7aRCPmVfZNJXN312gdxzHy+vPG9oLvfL+JO7iE3
 DHkRhnkRFnkBEeSw8jxDFtxk6nLlIr/LFTnx5fg/YOP7SxAxRMgFsD0ti6ML4IXPa8CVY0xevSge
 R3NdbzOtcJ7DTjeSZH4Vu+HhHIYSWnCgaE+yMzAEhKwRjbpPhOI9wEysA7hZDYVOnOOpvhoyJyFw
 4BshfO1Qw6NQscZ8NBOztPdQwU9xGjSl00MFZXXRKj/TNKUTLVAwKLe+1yl0yr0HCUuMMSQtyu0+
 pXQSu0HZK9nc4WZnqEcBFE5UQ/xD36knAfhZwfERkoYhjColiG9JDR/anxORrKEJAFpomzX8WUPG
 ZtQsy/sdTwGMdGG2NRKuVvNm3/fpxlSwul/x0FKpt32fUrOC5cmIIsZMUz4qsyzr1/lUbW8c5UiH
 QBrhYXauSDdUD990tNPJSpADlDHYdE8M6QPoJ4ULNPXNznG0bzH2MJ4ATBBu+NTUnAoYY5xxMsWe
 6Gqe1zSvasCYzxmZcjaDsX4hDB1UjX4HaTAqzJmcN30f79XLoMtWz6A++ihPAbB4rUBK2Wz5ewnf
 PlVgXGPUkLtlRs9ZKGjo7SAuxgxpLeG/o+nE2akaNibQcCdys127t+/TrfO3ehMdq27qOHTng21c
 w9Mk4C8vzW18o8CCW5tzaLvMXBrXFfwDmRTVdnC3Ri4AAAAASUVORK5CYII=
Date: Fri, 05 Jul 2019 14:59:52 +0200
In-Reply-To: <835zohboyc.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 04 Jul
 2019 22:05:15 +0300")
Message-ID: <m3muhsiqlz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: >> -
 (accept-process-output
 stream 0.05) >> + (accept-process-output stream 0.05 nil t) >> (goto-char
 start)) >> ;; Return the data we got back, or nil if the process died. >>
 (unless (= start (point) [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: contovob@HIDDEN, 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> -	  (accept-process-output stream 0.05)
>> +	  (accept-process-output stream 0.05 nil t)
>>  	  (goto-char start))
>>  	;; Return the data we got back, or nil if the process died.
>>  	(unless (= start (point))
>
> Does this mean you have other process objects active at that time?

Yes, normally when this code is triggered by the timer, there's other
networking happening more or less at the same time.

>> It's the JUST-THIS-ONE parameter: If that's non-nil, then
>> accept-process-output returns after the timeout...  and we get the data.
>
> I don't understand: accept-process-output is supposed to hit the
> timeout only when there's no data. 

That's not what the doc string says, I think?

--
Optional second argument SECONDS and third argument MILLISEC
specify a timeout; return after that much time even if there is
no subprocess output.
--

"even if"...  

> But you say "and we get the data".  So what am I missing here?

Without the JUST-THIS-ONE parameter, accept-process-output seems to loop
until the peer closes the connection.  And then control is returned to
Lisp world and the data is in the buffer.

The gdb-ing I did earlier seemed to say that this was not the case
(i.e., that it was looping in that loop above there), but Emacs
apparently behaves differently when stepping through in gdb than when
it's not...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 5 Jul 2019 08:22:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 05 04:22:59 2019
Received: from localhost ([127.0.0.1]:52324 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hjJUg-0004F7-P0
	for submit <at> debbugs.gnu.org; Fri, 05 Jul 2019 04:22:59 -0400
Received: from eggs.gnu.org ([209.51.188.92]:42574)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hjJUf-0004Ev-7G
 for 24201 <at> debbugs.gnu.org; Fri, 05 Jul 2019 04:22:57 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44806)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hjJTk-00050h-Kb; Fri, 05 Jul 2019 04:22:49 -0400
Received: from [176.228.60.248] (port=1165 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hjJTk-0000YN-2I; Fri, 05 Jul 2019 04:22:00 -0400
Date: Fri, 05 Jul 2019 11:21:51 +0300
Message-Id: <83v9wgao2o.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3a7du7xxl.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 04 Jul 2019 15:04:54 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: contovob@HIDDEN, 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: "Basil L. Contovounesios" <contovob@HIDDEN>,  24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Thu, 04 Jul 2019 15:04:54 +0200
> 
> I think this code looks suspicious:
> 
> 	  if (NILP (wait_for_cell) && just_wait_proc >= 0
> 	      && timespec_valid_p (timer_delay)
> 	      && timespec_cmp (timer_delay, timeout) < 0)
> 	    {
> 	      if (!timespec_valid_p (now))
> 		now = current_timespec ();
> 	      struct timespec timeout_abs = timespec_add (now, timeout);
> 	      if (!timespec_valid_p (got_output_end_time)
> 		  || timespec_cmp (timeout_abs, got_output_end_time) < 0)
> 		got_output_end_time = timeout_abs;
> 	      timeout = timer_delay;
> 	    }
> 	  else
> 	    got_output_end_time = invalid_timespec ();
> 
> This is done only if JUST-THIS-ONE is set.

There's also this:

      /* Wait till there is something to do.  */

      if (wait_proc && just_wait_proc)
	{
	  if (wait_proc->infd < 0)  /* Terminated.  */
	    break;
	  FD_SET (wait_proc->infd, &Available);
	  check_delay = 0;
          check_write = 0;
	}

In your case, wait_proc is non-NULL.

Can you tell which of the various conditions cause
accept-process-output to return after a timeout when you apply the
patch to network-stream.el?  Then we'd know for sure which part helps
avoid the loop when JUST-THIS-ONE is non-nil.

But what I'm missing is some description of the traffic that happens
on the wire.  Is the remote responding or isn't it, and if not, then
do we have any idea why?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 4 Jul 2019 19:05:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jul 04 15:05:36 2019
Received: from localhost ([127.0.0.1]:51891 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hj732-00046u-Bm
	for submit <at> debbugs.gnu.org; Thu, 04 Jul 2019 15:05:36 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51989)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hj730-00046g-Jh
 for 24201 <at> debbugs.gnu.org; Thu, 04 Jul 2019 15:05:35 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34159)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hj72u-0007Wk-Un; Thu, 04 Jul 2019 15:05:28 -0400
Received: from [176.228.60.248] (port=4061 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hj72r-0005y2-9m; Thu, 04 Jul 2019 15:05:28 -0400
Date: Thu, 04 Jul 2019 22:05:15 +0300
Message-Id: <835zohboyc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3a7du7xxl.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 04 Jul 2019 15:04:54 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN> <m3a7du7xxl.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: contovob@HIDDEN, 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: "Basil L. Contovounesios" <contovob@HIDDEN>,  24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Thu, 04 Jul 2019 15:04:54 +0200
> 
> With the following patch, connection never hangs:
> 
> diff --git a/lisp/net/network-stream.el b/lisp/net/network-stream.el
> index 2b3292b71b..cdb33a59f1 100644
> --- a/lisp/net/network-stream.el
> +++ b/lisp/net/network-stream.el
> @@ -376,7 +376,7 @@ network-stream-get-response
>  	(goto-char start)
>  	(while (and (memq (process-status stream) '(open run))
>  		    (not (re-search-forward end-of-command nil t)))
> -	  (accept-process-output stream 0.05)
> +	  (accept-process-output stream 0.05 nil t)
>  	  (goto-char start))
>  	;; Return the data we got back, or nil if the process died.
>  	(unless (= start (point))

Does this mean you have other process objects active at that time?

> It's the JUST-THIS-ONE parameter: If that's non-nil, then
> accept-process-output returns after the timeout...  and we get the data.

I don't understand: accept-process-output is supposed to hit the
timeout only when there's no data.  But you say "and we get the
data".  So what am I missing here?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 4 Jul 2019 13:05:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jul 04 09:05:03 2019
Received: from localhost ([127.0.0.1]:50554 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hj1Q6-00016Y-FS
	for submit <at> debbugs.gnu.org; Thu, 04 Jul 2019 09:05:02 -0400
Received: from quimby.gnus.org ([80.91.231.51]:35940)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hj1Q4-000160-LU
 for 24201 <at> debbugs.gnu.org; Thu, 04 Jul 2019 09:05:01 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hj1Py-0001Xn-8Z; Thu, 04 Jul 2019 15:04:56 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
 <m3o92eyjzj.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAElBMVEWqra7Z2tr////+//75
 +fnt7e0mEygKAAACcUlEQVQ4jXVUy5KjMAyUM3CXAr6H1z0kzB2CfLcT9P+/sm2Y1NZma3wyaqvV
 kttQ+8uiX4GGnh+hXg9AHsd3pz8b2x47cP6Jh7Dum2GzVwYuXwcQVDVs2IzfanuGe+znc9zGR2ba
 duCyFw+brrq8NvBWm6bHDuCjN5t09RZ8OzgLihANBuLFZNPJB0236FwYqj2Dnr2E5HVBRnoyM23+
 p3OEkmzJNls8RXbOHUAvZolIABiTiHMQlIHBiyUwSC2JiWcmCKIEtWbbzELuZUZOUqSc8YDowSwy
 TlZmjrw4Ag8oy7ZL4B5x0BZiLgvKxZt6fvZZjAiRi6gRhTE/Gi++VE3IvCIKFodqp0zVVLypUozj
 FcogVZjzrJJcU6kriS89UYl+Ysw9kM1NTZtSURQ4fWoTksp2pxKJRXCl5OMgb8ifjjuXOVGAzHm5
 8il7YXdBrgGxULMsSTgbQA+XyGhVSVApImkG0HW3++3W0lKfzzXGRkWJEWJwzI5d0VJ1OtfCNCPF
 VwyOy5WYypZOVeJ5JAyr/hJ6A8jwC8ckpBNJOku+tkknmDLLlNJR1t8IptrOUkiJDFp8hcHClbFs
 stNmKikXJ1+I1Gw36HG5jfgGasQdazZyd1im9j4DiJfGGpDSShpTssW0bim6qkDLOmWnY+boFX5B
 hoHLM6tOGJ07AJZTS98xWrHM2q14N2dOMGJscvE2OaREZOjHqx2YVhfXvl9vH885OX9Oqut6G9TU
 7uuk/Q70WcX6WBVTea+v3dSB2Yfwt8TlDXTT674/ZLMQtqDBp+c/v4xL7i17keCWj39JQ7zX+A/o
 7vf7pFu+qPaX9Qf/wZ/svmEzWwAAAABJRU5ErkJggg==
Date: Thu, 04 Jul 2019 15:04:54 +0200
In-Reply-To: <m3o92eyjzj.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sun,
 30 Jun 2019 21:02:40 +0200")
Message-ID: <m3a7du7xxl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  I've been poking more at this, and I think there really must
 be a bug somewhere in accept-process-output. With the following patch,
 connection never hangs: diff --git a/lisp/net/network-stream.el
 b/lisp/net/network-stream.el
 index 2b3292b71b..cdb33a59f1 100644 --- a/lisp/net/network-stream.el +++
 b/lisp/net/network-stream.el @@ -376,7 +376,7 @@ network-s [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: "Basil L. Contovounesios" <contovob@HIDDEN>, 24201 <at> debbugs.gnu.org,
 eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I've been poking more at this, and I think there really must be a bug
somewhere in accept-process-output.

With the following patch, connection never hangs:

diff --git a/lisp/net/network-stream.el b/lisp/net/network-stream.el
index 2b3292b71b..cdb33a59f1 100644
--- a/lisp/net/network-stream.el
+++ b/lisp/net/network-stream.el
@@ -376,7 +376,7 @@ network-stream-get-response
 	(goto-char start)
 	(while (and (memq (process-status stream) '(open run))
 		    (not (re-search-forward end-of-command nil t)))
-	  (accept-process-output stream 0.05)
+	  (accept-process-output stream 0.05 nil t)
 	  (goto-char start))
 	;; Return the data we got back, or nil if the process died.
 	(unless (= start (point))

It's the JUST-THIS-ONE parameter: If that's non-nil, then
accept-process-output returns after the timeout...  and we get the data.

Now, tracing the logic in wait_reading_process_output is rather...
difficult.  It's an 800 line function with lots of inputs from
everywhere.  But I think this code looks suspicious:

	  if (NILP (wait_for_cell) && just_wait_proc >= 0
	      && timespec_valid_p (timer_delay)
	      && timespec_cmp (timer_delay, timeout) < 0)
	    {
	      if (!timespec_valid_p (now))
		now = current_timespec ();
	      struct timespec timeout_abs = timespec_add (now, timeout);
	      if (!timespec_valid_p (got_output_end_time)
		  || timespec_cmp (timeout_abs, got_output_end_time) < 0)
		got_output_end_time = timeout_abs;
	      timeout = timer_delay;
	    }
	  else
	    got_output_end_time = invalid_timespec ();

This is done only if JUST-THIS-ONE is set.

But...  the timeout stuff is implemented in a very convoluted manner,
with reuse of certain variables that makes what this is trying to
achieve rather opaque. 

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 30 Jun 2019 19:02:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 30 15:02:50 2019
Received: from localhost ([127.0.0.1]:47296 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hhf69-0000gC-Ut
	for submit <at> debbugs.gnu.org; Sun, 30 Jun 2019 15:02:50 -0400
Received: from quimby.gnus.org ([80.91.231.51]:44084)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hhf67-0000g3-Un
 for 24201 <at> debbugs.gnu.org; Sun, 30 Jun 2019 15:02:48 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hhf60-0003U6-Lw; Sun, 30 Jun 2019 21:02:43 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83shg5z32d.fsf@HIDDEN> <87efrp2qw0.fsf@mouse>
 <83tw0lxjt3.fsf@HIDDEN> <m3r2pikwnu.fsf@HIDDEN>
 <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <87ftntkc53.fsf@HIDDEN> <83sgrthih6.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAElBMVEUnM0YFBQoNDxUJCg4V
 HSqMlJ6JYoCZAAACYUlEQVQ4jVWUQZLjIAxF1Q7sx/EFbIH3AaX3DMZ7ym3uf5X5wu7pGapSCf/x
 JSHZIUqpcOa9MrN7MscwTs5vnsgkMoO31Tlxz2UKI5YsTwXGZGNP4TBNUVQfpxEAKOecTJzem4zS
 HfAQWSqFHfPTzabEb/BWB3nvRMaJWquPSx+Zaq3JFIeD0EGWnuPJ2CFU3kRWq6CdCkJwajelINTR
 9WbV8hHUX6lkJ5/5AvWj5wgaGITFSrvJFUsdPfix2Zvg+/d0g8rOfOvNRevkqVUlUwf+q7dHqiJe
 75Ez0dyaybK4pFV+hYCWVMq8+rURPZbBx7WZzy2ItiRlns1eqf7+lYjZHlaCRPS2GOZjpzQs0+zE
 rPUMvbsE4K01X3tdqAq8DwCn40Db150ea6/1tA2z1FAJPeRkh69dgcetBsFCJF3enkd3FICHk8h0
 kbyeZwdDtTZjnqVPsJiy12OldlpT9UEq2feZY4RzNT1Hqu0QONASpEddpVHvFuZ4OMfCCnpl9ho5
 2XricWTuOfT2e1U9o5kArKBbUESre7OMRMcNLkfSwfTp7UP+F5SU7iT62Of4A5A9oXSifj4DmH75
 zMW8ybAZuqyhEEV1j73MRPr+xBuornvIxN+rh++6xEP4/A9cOrrwmnEHd+cwXr/70NZ53bQb+OCU
 0bSQxcmr2ismgKgDenyVOUs98GpFp4ccHDHi/AvN531gHbfuAxkNr0C73/W+AKJ69WpoCZYaNsFr
 YK4qLnwv/AZAsR6bnygyuw4cR3HuMsQOXh4eMlo2gIqqT6ICQG/nWwOFiD8fcWPctBV/AH6Qwf+K
 O+I4AAAAAElFTkSuQmCC
Date: Sun, 30 Jun 2019 21:02:40 +0200
In-Reply-To: <83sgrthih6.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 28 Jun
 2019 17:50:29 +0300")
Message-ID: <m3o92eyjzj.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: I'm able to reproduce the hang more often now by artificially
 closing the connection a lot and then letting it be reopened, so I'm now
 getting the hangs about once an hour when using Gnus. I changed the inflooping
 function like thus to record what's in it: 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: "Basil L. Contovounesios" <contovob@HIDDEN>, 24201 <at> debbugs.gnu.org,
 eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I'm able to reproduce the hang more often now by artificially closing
the connection a lot and then letting it be reopened, so I'm now getting
the hangs about once an hour when using Gnus.

I changed the inflooping function like thus to record what's in it:

(defun network-stream-get-response (stream start end-of-command)
  (when end-of-command
    (with-current-buffer (process-buffer stream)
      (save-excursion
	(goto-char start)
	(while (and (memq (process-status stream) '(open run))
		    (not (re-search-forward end-of-command nil t)))
          (push (list (format-time-string "%FT%T")
                      (point)
                      (current-buffer)
                      (buffer-string))
                lars-buffers)
	  (accept-process-output stream 0.05)
	  (goto-char start))

After making this change, I've only seen the hang twice, so this is all
very preliminary, but in both hangs, it didn't really loop there.

That is, in both instances, I got something like this as the top-level
element in `lars-buffers':

("2019-06-30T20:50:37" 1 #<buffer  *server news.gmane.org nntp  *Async Prefetch Article**> "")

and the next entries were from a successful connection.  And this is
after letting it hang for, say, ten seconds before `C-g'-ing it, so
there should be hundreds of elements there, since accept-process-output
is supposed to return after 0.05s.

What's in the buffer after `C-g' was, both times:

----

200 news.gmane.org InterNetNews NNRP server INN 2.6.1 ready (posting ok)^M

Process nntpd<3> connection broken by remote peer

----

I'll keep poking at this, but this is pointing at
`accept-process-output' having some kind of problem...  But we'll see;
perhaps these two hangs weren't typical...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 28 Jun 2019 14:51:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 28 10:51:13 2019
Received: from localhost ([127.0.0.1]:42765 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgsDY-0005bE-Ui
	for submit <at> debbugs.gnu.org; Fri, 28 Jun 2019 10:51:13 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41064)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hgsDW-0005b0-BX
 for 24201 <at> debbugs.gnu.org; Fri, 28 Jun 2019 10:51:10 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56711)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hgsDO-0005j0-PL; Fri, 28 Jun 2019 10:51:02 -0400
Received: from [176.228.60.248] (port=2239 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hgsDJ-0001uO-QF; Fri, 28 Jun 2019 10:51:00 -0400
Date: Fri, 28 Jun 2019 17:50:29 +0300
Message-Id: <83sgrthih6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
In-reply-to: <87ftntkc53.fsf@HIDDEN> (contovob@HIDDEN)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3pon8lbir.fsf@HIDDEN> <83d1j8e9c0.fsf@HIDDEN>
 <83shg5z32d.fsf@HIDDEN> <87efrp2qw0.fsf@mouse>
 <83tw0lxjt3.fsf@HIDDEN> <m3r2pikwnu.fsf@HIDDEN>
 <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN> <87ftntkc53.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: larsi@HIDDEN, eggert@HIDDEN, 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: "Basil L. Contovounesios" <contovob@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Fri, 28 Jun 2019 15:39:04 +0100
> 
> > 	(while (and (memq (process-status stream) '(open run))
> > 		    (not (re-search-forward end-of-command nil t)))
> > 	  (accept-process-output stream 0.05)
> > 	  (goto-char start))
> 
> This is probably unrelated, but isn't there a race condition between
> checking process-status and accepting output, as described in
> (info "(elisp) Accepting Output")?

Yes.  But the issue here is why it loops for such a long time, not why
it continues looping after the connection is closed.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 28 Jun 2019 14:39:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 28 10:39:14 2019
Received: from localhost ([127.0.0.1]:42751 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgs1y-0005Dn-92
	for submit <at> debbugs.gnu.org; Fri, 28 Jun 2019 10:39:14 -0400
Received: from mail-ed1-f65.google.com ([209.85.208.65]:38947)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1hgs1w-0005DZ-8q
 for 24201 <at> debbugs.gnu.org; Fri, 28 Jun 2019 10:39:12 -0400
Received: by mail-ed1-f65.google.com with SMTP id m10so11120491edv.6
 for <24201 <at> debbugs.gnu.org>; Fri, 28 Jun 2019 07:39:12 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=wEYSRl8XHqKYJrn2CnUs1f2cI5WHs5+WaHTNkOR8mGI=;
 b=e/nY4Cn7EeJ9Kfk58+ibCTqyg88nAwYgy7X0f4lb3rGUkB/DLu5zPugrsTMS2x9lye
 kRoaTGcR3xGmkufpdadYIrVAcnVz8YAQqzQwUVUSGhKASp6QXSFGTRQMaybYSM4aJfpM
 Fqc2ai07iihIGlrB4+rjHlO3p7ihQO2IHLjlOyKYrVrPcHQkagJghCm1ul7KSPSLHe+R
 vJVDCyaoDwu+ccUnS3tWbiMmxWTEi2ZStvfYs0cHqbL725dyhoa6fH/DHaVhyqB9trkF
 yyt000sr+u/vmuMa79ZwVKNThSO17riFVvtpoloGTjTykrdc6oKxBo7NS3t/qTYzqPRu
 W2fg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=wEYSRl8XHqKYJrn2CnUs1f2cI5WHs5+WaHTNkOR8mGI=;
 b=Mv/SZN90ZXlqONkKWmWc3eM9gktmJz1uAQ6Tia0aaQ0zNe7kwc7g5mBn2dBIg8VkT4
 MRROZcDWNDba3SRTFDvV7reudgqzFr+SvityfvIbmqVfu5ZoiZ8vsiOVtvxEmP+4QnfO
 iwmq+Sjmb7LG4awYW5Vfm3ATLA5Q9W+uZLiGnMDMDEUWMjgboWjFz+FnYUTlkf9YbRGV
 jPjmPyTrZnuU/vL/PsYBhOGflZJeZnVd67owY8/K2VA713Gc5M+IbfW7WmxiMD6gKo86
 bb35AuaHrGUIMhGcy0UBPqfPr9fg+j1dXCSUXpKrgeu5blhyz3k92+eNb83W+SDBW2S1
 ewhw==
X-Gm-Message-State: APjAAAV5rY/6/UQ0kP24CPZz+/2Vq8wu5+D1O/zDxFgQyrMmoBrSbra9
 jNsOD+ovFe7rHQXvN9jr6V+Hzg==
X-Google-Smtp-Source: APXvYqw6XXKdI9cMTgBKG+kEgouqUksX+jNgJttjAoQO1iicUlB+EqGv9m10l5pVzkNikOnLjTJnWw==
X-Received: by 2002:a17:906:6b53:: with SMTP id
 o19mr9120611ejs.27.1561732746358; 
 Fri, 28 Jun 2019 07:39:06 -0700 (PDT)
Received: from localhost ([2a02:8084:20e2:c380:92bd:1bfd:38fc:fae2])
 by smtp.gmail.com with ESMTPSA id l38sm749612eda.1.2019.06.28.07.39.05
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Fri, 28 Jun 2019 07:39:05 -0700 (PDT)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3pon8lbir.fsf@HIDDEN> <83d1j8e9c0.fsf@HIDDEN>
 <83shg5z32d.fsf@HIDDEN> <87efrp2qw0.fsf@mouse>
 <83tw0lxjt3.fsf@HIDDEN> <m3r2pikwnu.fsf@HIDDEN>
 <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
Date: Fri, 28 Jun 2019 15:39:04 +0100
In-Reply-To: <m3ftnvtiyz.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 27 Jun 2019 12:34:28 +0200")
Message-ID: <87ftntkc53.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: Eli Zaretskii <eliz@HIDDEN>, eggert@HIDDEN, 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>> OK, so that Ffuncall calls network-stream-get-response.  the next
>> question is what Lisp code runs 2 stack frames above, i.e. which Lisp
>> code calls some other Lisp code, which calls
>> network-stream-get-response?  Can you spot that?  The offending code
>> should be somewhere in network-stream-get-response or functions it
>> calls.
>>
>> Once we identify the Lisp code which loops, we need to try to figure
>> out why it loops.
>
> I'm pretty sure it's this:
>
> 	(while (and (memq (process-status stream) '(open run))
> 		    (not (re-search-forward end-of-command nil t)))
> 	  (accept-process-output stream 0.05)
> 	  (goto-char start))

This is probably unrelated, but isn't there a race condition between
checking process-status and accepting output, as described in
(info "(elisp) Accepting Output")?

Thanks,

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 28 Jun 2019 12:50:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 28 08:50:44 2019
Received: from localhost ([127.0.0.1]:40520 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgqKy-0001uv-21
	for submit <at> debbugs.gnu.org; Fri, 28 Jun 2019 08:50:44 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37867)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hgqKv-0001ui-E1
 for 24201 <at> debbugs.gnu.org; Fri, 28 Jun 2019 08:50:42 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54371)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hgqKn-0003mX-RR; Fri, 28 Jun 2019 08:50:34 -0400
Received: from [176.228.60.248] (port=1447 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hgpxz-0004Ri-IZ; Fri, 28 Jun 2019 08:27:02 -0400
Date: Fri, 28 Jun 2019 15:26:34 +0300
Message-Id: <835zopj3ph.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3y31mvxtu.fsf@HIDDEN> (message from Lars Ingebrigtsen on Fri, 
 28 Jun 2019 11:55:09 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <831rzfjh3i.fsf@HIDDEN> <m3tvcavndp.fsf@HIDDEN>
 <83lfxmi653.fsf@HIDDEN> <m3mui215h6.fsf@HIDDEN>
 <838stmhzwg.fsf@HIDDEN> <m3y31mvxtu.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Fri, 28 Jun 2019 11:55:09 +0200
> 
> Thanks for all the help with this, Eli.

I'm glad to be of any help I can extend.  Thanks for working on this
tricky problem.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 28 Jun 2019 09:55:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 28 05:55:18 2019
Received: from localhost ([127.0.0.1]:40408 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgnbC-0008BR-HA
	for submit <at> debbugs.gnu.org; Fri, 28 Jun 2019 05:55:18 -0400
Received: from quimby.gnus.org ([80.91.231.51]:59222)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hgnb9-0008BG-LN
 for 24201 <at> debbugs.gnu.org; Fri, 28 Jun 2019 05:55:16 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hgnb3-0000mi-Hw; Fri, 28 Jun 2019 11:55:13 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <831rzfjh3i.fsf@HIDDEN> <m3tvcavndp.fsf@HIDDEN>
 <83lfxmi653.fsf@HIDDEN> <m3mui215h6.fsf@HIDDEN>
 <838stmhzwg.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAHlBMVEXJZFXVk4iw4/6eyvm4
 6f6k1P2p2/7E8v4NAg93LjiWsMcBAAACH0lEQVQ4jV2UvY+bQBDFB6cJHVwT1xiTNjK2E7cWEnVC
 lj5YrJTeEnWUBjpyp5O8/23em4WzuREyML99b4b9sOQIY4y19mCTJEvwgHuSSO6JtcfjjgkP0rOC
 A0B2PGaX/ZksKRAyCyqb57ufKUk6gwPyzQ+fWSgU2AZpCFIF3QRa3wmHpgWEpQcsAZ9N3pCc06Lr
 uqsCHb+59YN7RX4BmuRy6xlf4VR218kK37Tx+f4PzAg6gtraaTziGQRWBIe6tb/nfD/sKVFgANbM
 OUfd63VWmPpS6dhIHG4v13LqypjqRDDGUcjyALiEU6uCXgDotb+DizqNcazgBVZFqaDl++CCj4OO
 KH1xg67Wqgh8W0N3B3x3IoFaTYoDgdaORORBMYNBJAo8+PxmZW8sEYXBO4XNvhGEqOKWxTPOYTjK
 qIq/M6jt9uS7cuHCqm62p5uC0PV3AEGT5TPQKZmtACpHEHnwPCmw4llTcZkYcMrLGTTY/rd+RJpd
 +RIAuu236x7f4VDF7R5A84tJcSNm6wPXtfRd2e/yEE+zoq03sohPxRUbiMW/SPAIgkLPh6mNSCxB
 hEmXKI5BVh6YSgF/JI65WsLD5YE6RLw0eHwB2FMg0ZTE7pKnBwDz0AsBVvYN0Nzxrk8r1mgBHF+5
 sigSe6tUcPRHh90ZE4iMHILiBcBlAQIUq3HqUcOMfFUrCUe4Of7RiK3xHSwSYpuws0j+tZjZ/zL/
 U9R22SUrAAAAAElFTkSuQmCC
Date: Fri, 28 Jun 2019 11:55:09 +0200
In-Reply-To: <838stmhzwg.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 28 Jun
 2019 11:34:07 +0300")
Message-ID: <m3y31mvxtu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: >> From: Lars
 Ingebrigtsen
 <larsi@HIDDEN> >> Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN >> Date:
 Fri, 28 Jun 2019 10:25:41 +0200 >> >> Oh, I just thought something -- this
 function (when it hangs [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Lars Ingebrigtsen <larsi@HIDDEN>
>> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
>> Date: Fri, 28 Jun 2019 10:25:41 +0200
>> 
>> Oh, I just thought something -- this function (when it hangs) is
>> always called from a timer.  Does the timer machinery set
>> `inhibit-quit'?
>
> Yes, it does: see timer_check_2.

Great; now at least I know where to disable the `inhibit-quit' so that I
can debug the infloop in network-stream more conveniently.

Thanks for all the help with this, Eli.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 28 Jun 2019 08:34:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 28 04:34:35 2019
Received: from localhost ([127.0.0.1]:40349 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgmKz-0006Ie-KI
	for submit <at> debbugs.gnu.org; Fri, 28 Jun 2019 04:34:35 -0400
Received: from eggs.gnu.org ([209.51.188.92]:56655)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hgmKx-0006IQ-IR
 for 24201 <at> debbugs.gnu.org; Fri, 28 Jun 2019 04:34:28 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39218)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hgmKr-0002Gi-Ro; Fri, 28 Jun 2019 04:34:22 -0400
Received: from [176.228.60.248] (port=3263 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hgmKq-00061g-AW; Fri, 28 Jun 2019 04:34:21 -0400
Date: Fri, 28 Jun 2019 11:34:07 +0300
Message-Id: <838stmhzwg.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3mui215h6.fsf@HIDDEN> (message from Lars Ingebrigtsen on Fri, 
 28 Jun 2019 10:25:41 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <831rzfjh3i.fsf@HIDDEN> <m3tvcavndp.fsf@HIDDEN>
 <83lfxmi653.fsf@HIDDEN> <m3mui215h6.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Fri, 28 Jun 2019 10:25:41 +0200
> 
> Oh, I just thought something -- this function (when it hangs) is
> always called from a timer.  Does the timer machinery set
> `inhibit-quit'?

Yes, it does: see timer_check_2.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 28 Jun 2019 08:25:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 28 04:25:49 2019
Received: from localhost ([127.0.0.1]:40341 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgmCb-00064l-9I
	for submit <at> debbugs.gnu.org; Fri, 28 Jun 2019 04:25:49 -0400
Received: from quimby.gnus.org ([80.91.231.51]:57948)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hgmCZ-00064b-Le
 for 24201 <at> debbugs.gnu.org; Fri, 28 Jun 2019 04:25:48 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hgmCT-0008OH-PH; Fri, 28 Jun 2019 10:25:45 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <831rzfjh3i.fsf@HIDDEN> <m3tvcavndp.fsf@HIDDEN>
 <83lfxmi653.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAHlBMVEXl3domGhujlJFUO0Bp
 X2ELBgf////+//4GAgMEAAEUmOamAAACaElEQVQ4jW2UPW/bMBCGBaNw56tEwN4cis1Okd5L8RKg
 I9ESoLdMzt4hmT0QoH6AAenf9kh9pEBzg23w4Xsfr0+q3q6fR/V2rT6JPYFXa1VvrelQ+hId5+Ix
 A6MQLWJnlZLAvO85b58LQI0CsV/BD1IUYDXmyAAy4BtoUAg0uAD3hVI9LgCVlBYU1JL5eodGFSCh
 7q3hO56DOQJ2BoqBVrh/2Z2q6wtzv4RSNoMrN1ZrPFVV1jBgUoGca0jeWKWxl0DFQUr6nlPpziil
 Oi1rmoOKUHOlXdBNq4nmbgEON7pkZ4A1aqs6aoYyHW80rJkBl0qh0n92X0kx3MieVfHQaLq+E5wG
 T1mBpTjTHLIfaBz4kG79CiSSuVRRmyxIMVtdgOC2a+lcmSwYY7MqBPY5k1KGhUThVoB8Pscnn88j
 kAsFZFMLkDCkIUUH0GwgS7SEaRym0UcPG5i7YlOOYfSsDLibgbbsQqfTOCUfnxeFQKvtwXsi4zDG
 sIEWJZ69Z4EUaQzpH6DKGgYqPsX0AYS1ZTuzggQzuJYa53Iewjjd0wc4CVME6T6kKfvoSyraejEL
 HI1OmejnBtj8BNwOKUa6sRZfwDC6MCSfxqUr2kBBO0stRXeh6dLW7okcOYc4TJFEKWbvCzhV3GqT
 QfAsjbm7tA5otWKB3PB+upEHcQNoj26gNP6Wn0Drw2b7YXJhyn7XPbf92a9ATnd3oFQhgub1t3YF
 4jh5AH+hfxt+C6k5W2q0w91Bgz/7vn8Ca+lzAQ9Ad+v6WCvJoJFYf1+W4SE/S8BoC5J3DTeq3b+S
 7e/v/79k8qtn//lr6S/WkkA7wT5z+QAAAABJRU5ErkJggg==
Date: Fri, 28 Jun 2019 10:25:41 +0200
In-Reply-To: <83lfxmi653.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 28 Jun
 2019 09:19:20 +0300")
Message-ID: <m3mui215h6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> I'm not sure -- I
 haven't been able to debug that at all. Since C-g >> doesn't work (and it
 happens so rarely and I have to catch it before the >> peer hangs up), it
 makes it awkward... > > You cou [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> I'm not sure -- I haven't been able to debug that at all.  Since C-g
>> doesn't work (and it happens so rarely and I have to catch it before the
>> peer hangs up), it makes it awkward...
>
> You could try using debug-on-event in conjunction with SIGUSR1/SIGUSR2
> to enter the debugger when you need.

Oh, that seems very useful; yes.  I'll set that up and try that the next
time it happens.

>> > Is inhibit-quit in fact nil or not inside this loop?
>> 
>> Looking at the code, I can't see any signs of it being inhibited here,
>> but I'm waiting for the next time it happens so that I can inspect with
>> gdb...
>
> You could also add a call to 'message' in that loop to print the value
> of the flag.

`inhibit-quit' is not set normally when that function is called (I just
checked), but perhaps...  Oh, I just thought something -- this function
(when it hangs) is always called from a timer.  Does the timer machinery
set `inhibit-quit'?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 28 Jun 2019 06:19:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 28 02:19:41 2019
Received: from localhost ([127.0.0.1]:40264 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgkEX-0002zZ-78
	for submit <at> debbugs.gnu.org; Fri, 28 Jun 2019 02:19:41 -0400
Received: from eggs.gnu.org ([209.51.188.92]:59680)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hgkEV-0002zN-HH
 for 24201 <at> debbugs.gnu.org; Fri, 28 Jun 2019 02:19:40 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:37781)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hgkEQ-0002Oq-Ae; Fri, 28 Jun 2019 02:19:34 -0400
Received: from [176.228.60.248] (port=2617 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hgkEP-0001YM-Rg; Fri, 28 Jun 2019 02:19:34 -0400
Date: Fri, 28 Jun 2019 09:19:20 +0300
Message-Id: <83lfxmi653.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3tvcavndp.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 27 Jun 2019 21:28:34 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <831rzfjh3i.fsf@HIDDEN> <m3tvcavndp.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Thu, 27 Jun 2019 21:28:34 +0200
> 
> >> 	(while (and (memq (process-status stream) '(open run))
> >> 		    (not (re-search-forward end-of-command nil t)))
> >> 	  (accept-process-output stream 0.05)
> >> 	  (goto-char start))
> >
> > Any idea why this loops?  Does the other end not respond or something?
> 
> I'm not sure -- I haven't been able to debug that at all.  Since C-g
> doesn't work (and it happens so rarely and I have to catch it before the
> peer hangs up), it makes it awkward...

You could try using debug-on-event in conjunction with SIGUSR1/SIGUSR2
to enter the debugger when you need.

> > Is inhibit-quit in fact nil or not inside this loop?
> 
> Looking at the code, I can't see any signs of it being inhibited here,
> but I'm waiting for the next time it happens so that I can inspect with
> gdb...

You could also add a call to 'message' in that loop to print the value
of the flag.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 27 Jun 2019 19:28:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 27 15:28:42 2019
Received: from localhost ([127.0.0.1]:39742 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hga4V-0007dh-Vm
	for submit <at> debbugs.gnu.org; Thu, 27 Jun 2019 15:28:42 -0400
Received: from quimby.gnus.org ([80.91.231.51]:47868)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hga4U-0007dX-Dr
 for 24201 <at> debbugs.gnu.org; Thu, 27 Jun 2019 15:28:38 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hga4Q-0000wF-Dj; Thu, 27 Jun 2019 21:28:36 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
 <831rzfjh3i.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAGFBMVEUuJy3Iub3o4+QHBQpS
 SU0XEhl7cXT18vT6phWfAAACeElEQVQ4jU2UQY/jIAyFvSr0PETd7HWCquYaiWHPVEM4IyXMuUgM
 982lf3+fSVuNKzWpP56NjSmN9/t91C/b+J19NAxKDZ162aDxc9B30gOencJDdTvQqtPDnc615lOn
 f9i9GV2Uyn23Pb0s3xrYObI2Pwfr9E+w4QNnraHmRh5gg0b5Wp33oSo1PsGmx+3iiUgIIpAfivFf
 IZKrrzeA7qXQQ+5dIoq+pHSsGbU/Qg25OhfXm4w+rTWrF+h7ckJGySCKnF9A3Sgtdj2kL7ek6K/P
 HOdayNjFmIRtLfHXK/nv4uICv4lOzlFcGbTGnDxF9i/T7Tt99ZnrABy3d0qJgZ38koS7NgDJdpLG
 GgYmJhPp+IfBiDaVT4ThFAxSIt7VpgHOcpWJJSlZCRBQRzv+2a5H2gFbvDLQox5IfhwPvKsHOWoN
 BToVF9siLcY2IGqmdtBh4R21/I2QyDS0WAcWoPYPs0RW+AYgmVsk83c2Cz1CKY2hOs97gfHAsSxK
 zAT3tl1cE5iFsUXjw55c64uVDGa4Z4szDorBuOl3Wxg47Hc2KdJL8T59tyQmTQk9aaHa5bgQRyEz
 zQA8X0/FcAqo3k2eTLLkS+iIL0Wb5l4mZ51Lc8SoAlQYz3hWbykYISWJ0sPFoHi2eovVhLcQQ+25
 csgKtCBFfE5Yhh9V1Er76hKYmxXyEjzfBRKh8m0pWOkNv/NCxMDQs3Z3GP4WnnNWchIHICOKSmRJ
 +IdVFAlFcRIDZ23EvCfRMLUkGdeJR9q2fiCaC7S2BAUOaeiAkI6YeQp76kJRCpLRcbacAwNc7qxA
 yKHfOKYka589Kld9+9vpK6/mPSQXgv8PehYV06BYfpEAAAAASUVORK5CYII=
Date: Thu, 27 Jun 2019 21:28:34 +0200
In-Reply-To: <831rzfjh3i.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 27 Jun
 2019 16:25:05 +0300")
Message-ID: <m3tvcavndp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: >> I'm pretty sure it's
 this: >> >> (while (and (memq (process-status stream) '(open run)) >> (not
 (re-search-forward end-of-command nil t))) >> (accept-process-output stream
 0.05) >> (goto-char start [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> I'm pretty sure it's this:
>> 
>> 	(while (and (memq (process-status stream) '(open run))
>> 		    (not (re-search-forward end-of-command nil t)))
>> 	  (accept-process-output stream 0.05)
>> 	  (goto-char start))
>
> Any idea why this loops?  Does the other end not respond or something?

I'm not sure -- I haven't been able to debug that at all.  Since C-g
doesn't work (and it happens so rarely and I have to catch it before the
peer hangs up), it makes it awkward...

>> But I do not understand why C-g doesn't work: I've tried to follow the
>> call chain, and I can see no instances of binding `inhibit-quit'...
>
> Is inhibit-quit in fact nil or not inside this loop?

Looking at the code, I can't see any signs of it being inhibited here,
but I'm waiting for the next time it happens so that I can inspect with
gdb...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 27 Jun 2019 13:25:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 27 09:25:31 2019
Received: from localhost ([127.0.0.1]:37671 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgUP4-0000OA-PO
	for submit <at> debbugs.gnu.org; Thu, 27 Jun 2019 09:25:31 -0400
Received: from eggs.gnu.org ([209.51.188.92]:56595)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hgUP3-0000Nx-L0
 for 24201 <at> debbugs.gnu.org; Thu, 27 Jun 2019 09:25:29 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50178)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hgUOx-000445-Ts; Thu, 27 Jun 2019 09:25:23 -0400
Received: from [176.228.60.248] (port=4151 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hgUOu-0001nU-Tu; Thu, 27 Jun 2019 09:25:21 -0400
Date: Thu, 27 Jun 2019 16:25:05 +0300
Message-Id: <831rzfjh3i.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3ftnvtiyz.fsf@HIDDEN> (message from Lars Ingebrigtsen on Thu, 
 27 Jun 2019 12:34:28 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN> <m3ftnvtiyz.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Thu, 27 Jun 2019 12:34:28 +0200
> 
> > Once we identify the Lisp code which loops, we need to try to figure
> > out why it loops.
> 
> I'm pretty sure it's this:
> 
> 	(while (and (memq (process-status stream) '(open run))
> 		    (not (re-search-forward end-of-command nil t)))
> 	  (accept-process-output stream 0.05)
> 	  (goto-char start))

Any idea why this loops?  Does the other end not respond or something?

> But I do not understand why C-g doesn't work: I've tried to follow the
> call chain, and I can see no instances of binding `inhibit-quit'...

Is inhibit-quit in fact nil or not inside this loop?

> If C-g worked, it'd be easier to debug...

If you are running this under GDB, you can interrupt by "GDB ways",
they are described in etc/DEBUG.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 27 Jun 2019 10:34:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 27 06:34:34 2019
Received: from localhost ([127.0.0.1]:37482 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgRje-0000Cf-1u
	for submit <at> debbugs.gnu.org; Thu, 27 Jun 2019 06:34:34 -0400
Received: from quimby.gnus.org ([80.91.231.51]:39026)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hgRjc-0000CX-DH
 for 24201 <at> debbugs.gnu.org; Thu, 27 Jun 2019 06:34:32 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hgRjY-00045O-7s; Thu, 27 Jun 2019 12:34:30 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
 <83h88cjoiv.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAElBMVEUuNC0RFxeinYRjYlIE
 BQXj5tyl3TBQAAACTElEQVQ4jXWTTXLkIAyFhdWzlwIHcEPYA+rs7QoHyLjL979KHnZ1J6nMsGla
 H3r6NfXnyfv3Q/8F7+kGo91+e7xatf767n+DmlpI9e9vcEvcZ04n2GKO8QSXy6V0puUEKbUH+JFV
 S1uKbdwoPs8QMsv31saVfkS8V2qJ/wE+HHEhajF/B1tORWFvNtl3kCOTkhGULLYvkCIee8jQy1Zi
 egL8Yaqe6sScET0+wL3EGVJSmN2ESsoDpGKFHII4my1PGz3AoS9tdm66tx310yMECRze7mWhKbWc
 2hcg11F2UZnQl7k9pUqlQFYcEZmP8zMrxLYLEQ9FE/TkIYWH5ApAcUqKWiiewPCURKQ6EROjfHQS
 x4a4qrouqGaiifb5DfZYHApUZe2qvUsx2q8ZGxBnNXPaV4wYft17yvDYIpvwAH0NK/RUGrU2dobc
 iBHWVdyR33TWkfBYkWhfkQDbSKTRuU3wHtKrOhJOzpAVcsr7MC8OUiLsS0pcmRAi7lddlWMI66jR
 LPLVkw2tKxK0ViG1IBZHnoVekNT+0TumlEZ14otPbETveTuAeqsO5SEKlwH0z932KyrjNmvAr4qz
 xh7RnGu30INyogFcEB8Len1Bw9GI0AVzhUNf15cEKQ50KhxgFUWzPFvDCshh7n0ZjbGCKoktU1jK
 6PRwGvMo6SLoW/v61Eav8DilIE4ZQCUMG55hPzT4ecHNIkCpdXJonWoy1rX4wmQtk1bP3pv3IzD2
 mj0XFAhgZr4aTxCoFQOeJuwex2Nl9JyT+jHI40rtE1wXxbz7f8U6AAAAAElFTkSuQmCC
Date: Thu, 27 Jun 2019 12:34:28 +0200
In-Reply-To: <83h88cjoiv.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 26 Jun
 2019 19:32:24 +0300")
Message-ID: <m3ftnvtiyz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > OK, so that Ffuncall
 calls network-stream-get-response. the next > question is what Lisp code
 runs 2 stack frames above, i.e. which Lisp > code calls some other Lisp code, 
 which calls > network-stre [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> OK, so that Ffuncall calls network-stream-get-response.  the next
> question is what Lisp code runs 2 stack frames above, i.e. which Lisp
> code calls some other Lisp code, which calls
> network-stream-get-response?  Can you spot that?  The offending code
> should be somewhere in network-stream-get-response or functions it
> calls.
>
> Once we identify the Lisp code which loops, we need to try to figure
> out why it loops.

I'm pretty sure it's this:

	(while (and (memq (process-status stream) '(open run))
		    (not (re-search-forward end-of-command nil t)))
	  (accept-process-output stream 0.05)
	  (goto-char start))

But I do not understand why C-g doesn't work: I've tried to follow the
call chain, and I can see no instances of binding `inhibit-quit'...

If C-g worked, it'd be easier to debug...

>> And upon continuing, Emacs un-stuck with the following message:
>>=20
>> Error running timer =E2=80=98gnus-async-prefetch-article=E2=80=99: (erro=
r "Server
>> closed connection")
>
> So probably we loop until the other side closes the connection?

Yup.

--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 26 Jun 2019 16:32:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 26 12:32:51 2019
Received: from localhost ([127.0.0.1]:36929 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgAqp-0002DX-6W
	for submit <at> debbugs.gnu.org; Wed, 26 Jun 2019 12:32:51 -0400
Received: from eggs.gnu.org ([209.51.188.92]:52582)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hgAqm-0002DC-Ej
 for 24201 <at> debbugs.gnu.org; Wed, 26 Jun 2019 12:32:48 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55206)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hgAqh-00009F-9W; Wed, 26 Jun 2019 12:32:43 -0400
Received: from [176.228.60.248] (port=3408 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hgAqe-0002ow-IE; Wed, 26 Jun 2019 12:32:41 -0400
Date: Wed, 26 Jun 2019 19:32:24 +0300
Message-Id: <83h88cjoiv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3o92luy40.fsf@HIDDEN> (message from Lars Ingebrigtsen on Tue, 
 25 Jun 2019 23:57:35 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN> <m3o92luy40.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Tue, 25 Jun 2019 23:57:35 +0200
> 
> (gdb) finish
> Run till exit from #0  0x0000555555721250 in exec_byte_code (
>     bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
>     args_template=<optimized out>, nargs=nargs@entry=3, args=<optimized out>, 
>     args@entry=0x31) at bytecode.c:633
> Ffuncall (nargs=4, args=args@entry=0x7fffffffb770) at eval.c:2826
> 2826	  lisp_eval_depth--;
> Value returned is $38 = (union Lisp_X *) 0x0
> (gdb) p args[0]
> $39 = XIL(0x1401750)
> (gdb) xsymbol 
> $40 = (struct Lisp_Symbol *) 0x555557199570
> "network-stream-get-response"

OK, so that Ffuncall calls network-stream-get-response.  the next
question is what Lisp code runs 2 stack frames above, i.e. which Lisp
code calls some other Lisp code, which calls
network-stream-get-response?  Can you spot that?  The offending code
should be somewhere in network-stream-get-response or functions it
calls.

Once we identify the Lisp code which loops, we need to try to figure
out why it loops.

> And upon continuing, Emacs un-stuck with the following message:
> 
> Error running timer ‘gnus-async-prefetch-article’: (error "Server closed connection")

So probably we loop until the other side closes the connection?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 26 Jun 2019 16:29:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 26 12:29:51 2019
Received: from localhost ([127.0.0.1]:36925 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hgAnv-00026r-Ml
	for submit <at> debbugs.gnu.org; Wed, 26 Jun 2019 12:29:51 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51915)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hgAnu-00026d-6e
 for 24201 <at> debbugs.gnu.org; Wed, 26 Jun 2019 12:29:51 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55164)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hgAno-0006J9-9A; Wed, 26 Jun 2019 12:29:44 -0400
Received: from [176.228.60.248] (port=3229 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hgAnm-0007SL-3J; Wed, 26 Jun 2019 12:29:42 -0400
Date: Wed, 26 Jun 2019 19:29:26 +0300
Message-Id: <83imssjont.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m38stpzdbu.fsf@HIDDEN> (message from Lars Ingebrigtsen on Tue, 
 25 Jun 2019 21:15:17 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN> <m38stpzdbu.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Tue, 25 Jun 2019 21:15:17 +0200
> 
> So, the "finish" stuff seemed to show that we weren't hanging in
> accept-process-output at all, but were instead just calling functions as
> normal, and looping on the Lisp level?

That's my current hypothesis, yes.

> And, for instance, Ffuncall has a maybe_quit, so C-g should work in
> these instances?  But they don't, which is confusing.

The loop is not in Ffuncall, it's in some Lisp that calls Ffuncall.
Those are the two stack frames running bytecode above the frame with
Ffuncall.

> Is it even possible for the Lisp-ier functions in the backtrace to
> inhibit C-g?

Yes, they can set inhibit-quit.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 25 Jun 2019 21:57:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 25 17:57:46 2019
Received: from localhost ([127.0.0.1]:33757 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hftRf-0004i9-Du
	for submit <at> debbugs.gnu.org; Tue, 25 Jun 2019 17:57:44 -0400
Received: from quimby.gnus.org ([80.91.231.51]:57432)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hftRc-0004hx-NW
 for 24201 <at> debbugs.gnu.org; Tue, 25 Jun 2019 17:57:41 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hftRX-0004oA-U2; Tue, 25 Jun 2019 23:57:38 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
 <m38stpzdbu.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAElBMVEVNTVLq6uwgHBsPCgiJ
 i5MKBgQ52b9hAAACZUlEQVQ4jU2TQZa0KgyFAXFeVLMAO+jcQ8o5aGoDxcn+t/InUPZ7jJSPC8m9
 YIyDxejw9DccuWRCZKIxC+a7JkHKCuqTP0Xm0GEGAL8gIgho4WKWbzy+oKQbzNwcCMkHJIA1ToiL
 bhWmlw+yjDPaM8MaLlnTFcXUWNKK+2aDE/DcN+yKEC44kFQh4Ff/sStC+GnYTjnDRujgfSseyK+T
 d7RPAT7W6wYRP+QPl+yUwVO073urkF5EaNAmzLgU4V9FcPkT2aGdtB1jJ+0DFTyPV0Q47I/aAXWG
 e6tHrpFzsjHJ/FL/U4QagpYbovO+hrl3DjoW41QRxpi0KtFu3LJUlY8MYwxLwKQPAoklSd2HpCHo
 VktKGfVw8U7amGT+GFtphdnSARtoTQp6gzThWuBX9kwL5sWIrgeFJL56MhHdsUqCCg4FjS45MNeT
 E/oLwJ44EkSaF5NwL7LQhhPqE3Mvtw2A2FASfECI9ZsgnV0OPBTxL1oKrv5kHxVEXEjI1b2ikq38
 dPBkzqWOzOVw3sW9eExsI8vlE9DzoDfvqyqSHD43XORwBZlKagpw0jyMIbk+o8EaSXKKbcI7j2vp
 Cuo/URr0N+hV9cdiSDpHT/8HqWnb2TU1tY/S7xVujSUPoG6qvEkZ/ak1x+zlqRH/KQZAn3iXB2Iw
 HSsNMhRerM1QC0uSJ+5UBPQEvUxLHtrg7yURSewdfAiXRUUolkyOiqz6ggRm+gblpMViUi830wSr
 w/7SbTEC3AAfEduH7M3YvVJ1Gorg7IO6Vwo2eajbpysiqEWRD1bwZn7NrStmCVxtnzuQdGlr/wCo
 tqfdPMVLTQAAAABJRU5ErkJggg==
Date: Tue, 25 Jun 2019 23:57:35 +0200
In-Reply-To: <m38stpzdbu.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Tue,
 25 Jun 2019 21:15:17 +0200")
Message-ID: <m3o92luy40.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  OK, got another one. I hit C-g a bunch in Emacs first, but
 got no response, and then TSTP-d the process: Thread 1 "emacs" received signal
 SIGTSTP, Stopped (user). pthread_sigmask (how=how@entry=0, newmask=<optimized
 out>, newmask@entry=0x7fffffffa550, oldmask=oldmask@entry=0x7fffffffa5f0)
 at ../sysdeps/u [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

OK, got another one.  I hit C-g a bunch in Emacs first, but got no
response, and then TSTP-d the process:

Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
pthread_sigmask (how=3Dhow@entry=3D0, newmask=3D<optimized out>,=20
    newmask@entry=3D0x7fffffffa550, oldmask=3Doldmask@entry=3D0x7fffffffa5f=
0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
50	../sysdeps/unix/sysv/linux/pthread_sigmask.c: No such file or directory.
(gdb) finish
Run till exit from #0  pthread_sigmask (how=3Dhow@entry=3D0,=20
    newmask=3D<optimized out>, newmask@entry=3D0x7fffffffa550,=20
    oldmask=3Doldmask@entry=3D0x7fffffffa5f0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
block_interrupt_signal (oldset=3Doldset@entry=3D0x7fffffffa5f0) at sysdep.c=
:868
868	}
Value returned is $21 =3D 0
(gdb) finish
Run till exit from #0  block_interrupt_signal (
    oldset=3Doldset@entry=3D0x7fffffffa5f0) at sysdep.c:868
really_call_select (arg=3D0x7fffffffa690) at thread.c:594
594	  if (self->not_holding_lock)
(gdb) finish
Run till exit from #0  really_call_select (arg=3D0x7fffffffa690) at thread.=
c:594
thread_select (func=3D<optimized out>, max_fds=3Dmax_fds@entry=3D22,=20
    rfds=3Drfds@entry=3D0x7fffffffa760, wfds=3Dwfds@entry=3D0x7fffffffa7e0,=
=20
    efds=3Defds@entry=3D0x0, timeout=3Dtimeout@entry=3D0x7fffffffadb0, sigm=
ask=3D0x0)
    at thread.c:618
618	}
(gdb) finish
Run till exit from #0  thread_select (func=3D<optimized out>,=20
    max_fds=3Dmax_fds@entry=3D22, rfds=3Drfds@entry=3D0x7fffffffa760,=20
    wfds=3Dwfds@entry=3D0x7fffffffa7e0, efds=3Defds@entry=3D0x0,=20
    timeout=3Dtimeout@entry=3D0x7fffffffadb0, sigmask=3D0x0) at thread.c:618
xg_select (fds_lim=3D22, rfds=3Drfds@entry=3D0x7fffffffaee0,=20
    wfds=3Dwfds@entry=3D0x7fffffffaf60, efds=3Defds@entry=3D0x0,=20
    timeout=3Dtimeout@entry=3D0x7fffffffadb0, sigmask=3Dsigmask@entry=3D0x0)
    at xgselect.c:120
120	  if (nfds < 0)
Value returned is $22 =3D 1
(gdb) finish
Run till exit from #0  xg_select (fds_lim=3D22, rfds=3Drfds@entry=3D0x7ffff=
fffaee0,=20
    wfds=3Dwfds@entry=3D0x7fffffffaf60, efds=3Defds@entry=3D0x0,=20
    timeout=3Dtimeout@entry=3D0x7fffffffadb0, sigmask=3Dsigmask@entry=3D0x0)
    at xgselect.c:120
wait_reading_process_output (time_limit=3D<optimized out>,=20
    nsecs=3D<optimized out>, read_kbd=3Dread_kbd@entry=3D0,=20
    do_display=3Ddo_display@entry=3Dfalse,=20
    wait_for_cell=3Dwait_for_cell@entry=3DXIL(0),=20
    wait_proc=3Dwait_proc@entry=3D0x55555c0176e0, just_wait_proc=3D0)
    at process.c:5447
5447	          if (nfds =3D=3D 0)
Value returned is $23 =3D 1
(gdb) finish
Run till exit from #0  wait_reading_process_output (
    time_limit=3D<optimized out>, nsecs=3D<optimized out>,=20
    read_kbd=3Dread_kbd@entry=3D0, do_display=3Ddo_display@entry=3Dfalse,=20
    wait_for_cell=3Dwait_for_cell@entry=3DXIL(0),=20
    wait_proc=3Dwait_proc@entry=3D0x55555c0176e0, just_wait_proc=3D0)
    at process.c:5447
Faccept_process_output (process=3DXIL(0x55555c0176e5), seconds=3D<optimized=
 out>,=20
    millisec=3D<optimized out>, just_this_one=3D<optimized out>) at process=
.c:4715
4715	     ? Qnil : Qt);
Value returned is $24 =3D 74
(gdb) finish
Run till exit from #0  Faccept_process_output (process=3DXIL(0x55555c0176e5=
),=20
    seconds=3D<optimized out>, millisec=3D<optimized out>,=20
    just_this_one=3D<optimized out>) at process.c:4715
0x00005555556ea7c9 in Ffuncall (nargs=3D3, args=3Dargs@entry=3D0x7fffffffb1=
e0)
    at eval.c:2803
2803	    val =3D funcall_subr (XSUBR (fun), numargs, args + 1);
Value returned is $25 =3D (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x00005555556ea7c9 in Ffuncall (nargs=3D3,=20
    args=3Dargs@entry=3D0x7fffffffb1e0) at eval.c:2803
0x0000555555721250 in exec_byte_code (bytestr=3D<optimized out>,=20
    vector=3D<optimized out>, maxdepth=3D<optimized out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D3, args=3D<optim=
ized out>,=20
    args@entry=3D0x35) at bytecode.c:633
633		    TOP =3D Ffuncall (op + 1, &TOP);
Value returned is $26 =3D (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x0000555555721250 in exec_byte_code (
    bytestr=3D<optimized out>, vector=3D<optimized out>, maxdepth=3D<optimi=
zed out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D3, args=3D<optim=
ized out>,=20
    args@entry=3D0x35) at bytecode.c:633
Ffuncall (nargs=3D4, args=3Dargs@entry=3D0x7fffffffb470) at eval.c:2826
2826	  lisp_eval_depth--;
Value returned is $27 =3D (union Lisp_X *) 0x0

---
OK, so here's I'm at the lisp_eval_depth--.
---

(gdb) p args[0]
$28 =3D XIL(0x1401750)
(gdb) xsymbol=20
$29 =3D (struct Lisp_Symbol *) 0x555557199570
"network-stream-get-response"
(gdb) xbacktrace=20
"network-stream-get-response" (0xffffb478)
"network-stream-open-starttls" (0xffffb928)
"open-network-stream" (0xffffbc10)
"nntp-open-connection" (0xffffc0f0)
"nntp-open-server" (0xffffc3f0)
"nntp-possibly-change-group" (0xffffcaa0)
"nntp-with-open-group-function" (0xffffcd40)
"nntp-request-article" (0xffffcfb0)
"gnus-request-article" (0xffffd278)
"gnus-async-prefetch-article" (0xffffd588)
"apply" (0xffffd698)
"timer-event-handler" (0xffffd948)


And then there's a couple more of the same things: Emacs continues after
a few more finishes, and I TSTP it:


(gdb) finish
Run till exit from #0  Ffuncall (nargs=3D4, args=3Dargs@entry=3D0x7fffffffb=
470)
    at eval.c:2826
0x0000555555721250 in exec_byte_code (bytestr=3D<optimized out>,=20
    vector=3D<optimized out>, maxdepth=3D<optimized out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D5, args=3D<optim=
ized out>,=20
    args@entry=3D0x34) at bytecode.c:633
633		    TOP =3D Ffuncall (op + 1, &TOP);
Value returned is $30 =3D (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  0x0000555555721250 in exec_byte_code (
    bytestr=3D<optimized out>, vector=3D<optimized out>, maxdepth=3D<optimi=
zed out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D5, args=3D<optim=
ized out>,=20
    args@entry=3D0x34) at bytecode.c:633

^Z
Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
0x00005555556ca609 in cons_marked_p (c=3D0x55556da37da0) at alloc.c:3774
3774	    : XCONS_MARKED_P (c);
(gdb) xbacktrace=20
"Automatic GC" (0x0)
"timer-event-handler" (0xffffaec8)
"accept-process-output" (0xffffb4e8)
"network-stream-get-response" (0xffffb778)
"network-stream-open-starttls" (0xffffbc28)
"open-network-stream" (0xffffbf10)
"nntp-open-connection" (0xffffc3f0)
"nntp-possibly-change-group" (0xffffcaa0)
"nntp-with-open-group-function" (0xffffcd40)
"nntp-request-article" (0xffffcfb0)
"gnus-request-article" (0xffffd278)
"gnus-async-prefetch-article" (0xffffd588)
"apply" (0xffffd698)
"timer-event-handler" (0xffffd948)
(gdb) finish
Run till exit from #0  0x00005555556ca609 in cons_marked_p (c=3D0x55556da37=
da0)
    at alloc.c:3774
mark_object (arg=3D<optimized out>) at alloc.c:6566
6566		if (cons_marked_p (ptr))
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6566
mark_object (arg=3D<optimized out>) at alloc.c:6580
6580		if (cdr_count =3D=3D mark_object_loop_halt)
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6580
mark_object (arg=3D<optimized out>) at alloc.c:6580
6580		if (cdr_count =3D=3D mark_object_loop_halt)
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6580
mark_object (arg=3D<optimized out>) at alloc.c:6580
6580		if (cdr_count =3D=3D mark_object_loop_halt)
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6580
mark_object (arg=3D<optimized out>) at alloc.c:6580
6580		if (cdr_count =3D=3D mark_object_loop_halt)
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6580
mark_localized_symbol (ptr=3D<optimized out>) at alloc.c:6228
6228	  mark_object (blv->defcell);
(gdb) finish
Run till exit from #0  mark_localized_symbol (ptr=3D<optimized out>)
    at alloc.c:6228
mark_object (arg=3D<optimized out>) at alloc.c:6544
6544		    break;
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6544
mark_vectorlike (header=3D0x555556e35a20) at alloc.c:6105
6105	  for (i =3D 0; i < size; i++) /* ...and then mark its elements.  */
(gdb) finish
Run till exit from #0  mark_vectorlike (header=3D0x555556e35a20) at alloc.c=
:6105
mark_object (arg=3D<optimized out>) at alloc.c:6531
6531		mark_object (ptr->u.s.plist);
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6531
mark_vectorlike (header=3D0x555556e51a40) at alloc.c:6105
6105	  for (i =3D 0; i < size; i++) /* ...and then mark its elements.  */
(gdb) finish
Run till exit from #0  mark_vectorlike (header=3D0x555556e51a40) at alloc.c=
:6105
mark_object (arg=3D<optimized out>) at alloc.c:6531
6531		mark_object (ptr->u.s.plist);
(gdb) finish
Run till exit from #0  mark_object (arg=3D<optimized out>) at alloc.c:6531
mark_vectorlike (header=3D0x555556e5a7b0) at alloc.c:6105
6105	  for (i =3D 0; i < size; i++) /* ...and then mark its elements.  */
(gdb) finish
Run till exit from #0  mark_vectorlike (header=3D0x555556e5a7b0) at alloc.c=
:6105
mark_object (arg=3D<optimized out>) at alloc.c:6531
6531		mark_object (ptr->u.s.plist);

But I landed inside a gc, so I just cont:

(gdb) cont
Continuing.
^Z
Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
pthread_sigmask (how=3Dhow@entry=3D0, newmask=3D<optimized out>,=20
    newmask@entry=3D0x7fffffffa550, oldmask=3Doldmask@entry=3D0x7fffffffa5f=
0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
50	../sysdeps/unix/sysv/linux/pthread_sigmask.c: No such file or directory.
(gdb) finish
Run till exit from #0  pthread_sigmask (how=3Dhow@entry=3D0,=20
    newmask=3D<optimized out>, newmask@entry=3D0x7fffffffa550,=20
    oldmask=3Doldmask@entry=3D0x7fffffffa5f0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
block_interrupt_signal (oldset=3Doldset@entry=3D0x7fffffffa5f0) at sysdep.c=
:868
868	}
Value returned is $31 =3D 0
(gdb) cont
Continuing.
^Z

And then a new TSTP:

Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
pthread_sigmask (how=3Dhow@entry=3D0, newmask=3D<optimized out>,=20
    newmask@entry=3D0x7fffffffa850, oldmask=3Doldmask@entry=3D0x7fffffffa8f=
0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
50	../sysdeps/unix/sysv/linux/pthread_sigmask.c: No such file or directory.
(gdb) xbacktrace=20
"accept-process-output" (0xffffb4e8)
"network-stream-get-response" (0xffffb778)
"network-stream-open-starttls" (0xffffbc28)
"open-network-stream" (0xffffbf10)
"nntp-open-connection" (0xffffc3f0)
"nntp-possibly-change-group" (0xffffcaa0)
"nntp-with-open-group-function" (0xffffcd40)
"nntp-request-article" (0xffffcfb0)
"gnus-request-article" (0xffffd278)
"gnus-async-prefetch-article" (0xffffd588)
"apply" (0xffffd698)
"timer-event-handler" (0xffffd948)
(gdb) finish
Run till exit from #0  pthread_sigmask (how=3Dhow@entry=3D0,=20
    newmask=3D<optimized out>, newmask@entry=3D0x7fffffffa850,=20
    oldmask=3Doldmask@entry=3D0x7fffffffa8f0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
block_interrupt_signal (oldset=3Doldset@entry=3D0x7fffffffa8f0) at sysdep.c=
:868
868	}
Value returned is $32 =3D 0
(gdb) finish
Run till exit from #0  block_interrupt_signal (
    oldset=3Doldset@entry=3D0x7fffffffa8f0) at sysdep.c:868
really_call_select (arg=3D0x7fffffffa990) at thread.c:583
583	  release_global_lock ();
(gdb) finish
Run till exit from #0  really_call_select (arg=3D0x7fffffffa990) at thread.=
c:583
thread_select (func=3D<optimized out>, max_fds=3Dmax_fds@entry=3D22,=20
    rfds=3Drfds@entry=3D0x7fffffffaa60, wfds=3Dwfds@entry=3D0x7fffffffaae0,=
=20
    efds=3Defds@entry=3D0x0, timeout=3Dtimeout@entry=3D0x7fffffffb0b0, sigm=
ask=3D0x0)
    at thread.c:618
618	}
(gdb) finish
Run till exit from #0  thread_select (func=3D<optimized out>,=20
    max_fds=3Dmax_fds@entry=3D22, rfds=3Drfds@entry=3D0x7fffffffaa60,=20
    wfds=3Dwfds@entry=3D0x7fffffffaae0, efds=3Defds@entry=3D0x0,=20
    timeout=3Dtimeout@entry=3D0x7fffffffb0b0, sigmask=3D0x0) at thread.c:618
xg_select (fds_lim=3D22, rfds=3Drfds@entry=3D0x7fffffffb1e0,=20
    wfds=3Dwfds@entry=3D0x7fffffffb260, efds=3Defds@entry=3D0x0,=20
    timeout=3Dtimeout@entry=3D0x7fffffffb0b0, sigmask=3Dsigmask@entry=3D0x0)
    at xgselect.c:120
120	  if (nfds < 0)
Value returned is $33 =3D 3
(gdb) finish
Run till exit from #0  xg_select (fds_lim=3D22, rfds=3Drfds@entry=3D0x7ffff=
fffb1e0,=20
    wfds=3Dwfds@entry=3D0x7fffffffb260, efds=3Defds@entry=3D0x0,=20
    timeout=3Dtimeout@entry=3D0x7fffffffb0b0, sigmask=3Dsigmask@entry=3D0x0)
    at xgselect.c:120
wait_reading_process_output (time_limit=3D<optimized out>,=20
    nsecs=3D<optimized out>, read_kbd=3Dread_kbd@entry=3D0,=20
    do_display=3Ddo_display@entry=3Dfalse,=20
    wait_for_cell=3Dwait_for_cell@entry=3DXIL(0),=20
    wait_proc=3Dwait_proc@entry=3D0x555560255dc0, just_wait_proc=3D0)
    at process.c:5447
5447	          if (nfds =3D=3D 0)
Value returned is $34 =3D 2
(gdb) finish
Run till exit from #0  wait_reading_process_output (
    time_limit=3D<optimized out>, nsecs=3D<optimized out>,=20
    read_kbd=3Dread_kbd@entry=3D0, do_display=3Ddo_display@entry=3Dfalse,=20
    wait_for_cell=3Dwait_for_cell@entry=3DXIL(0),=20
    wait_proc=3Dwait_proc@entry=3D0x555560255dc0, just_wait_proc=3D0)
    at process.c:5447
Faccept_process_output (process=3DXIL(0x555560255dc5), seconds=3D<optimized=
 out>,=20
    millisec=3D<optimized out>, just_this_one=3D<optimized out>) at process=
.c:4715
4715	     ? Qnil : Qt);
Value returned is $35 =3D 74
(gdb) finish
Run till exit from #0  Faccept_process_output (process=3DXIL(0x555560255dc5=
),=20
    seconds=3D<optimized out>, millisec=3D<optimized out>,=20
    just_this_one=3D<optimized out>) at process.c:4715
0x00005555556ea7c9 in Ffuncall (nargs=3D3, args=3Dargs@entry=3D0x7fffffffb4=
e0)
    at eval.c:2803
2803	    val =3D funcall_subr (XSUBR (fun), numargs, args + 1);
Value returned is $36 =3D (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x00005555556ea7c9 in Ffuncall (nargs=3D3,=20
    args=3Dargs@entry=3D0x7fffffffb4e0) at eval.c:2803
0x0000555555721250 in exec_byte_code (bytestr=3D<optimized out>,=20
    vector=3D<optimized out>, maxdepth=3D<optimized out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D3, args=3D<optim=
ized out>,=20
    args@entry=3D0x31) at bytecode.c:633
633		    TOP =3D Ffuncall (op + 1, &TOP);
Value returned is $37 =3D (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x0000555555721250 in exec_byte_code (
    bytestr=3D<optimized out>, vector=3D<optimized out>, maxdepth=3D<optimi=
zed out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D3, args=3D<optim=
ized out>,=20
    args@entry=3D0x31) at bytecode.c:633
Ffuncall (nargs=3D4, args=3Dargs@entry=3D0x7fffffffb770) at eval.c:2826
2826	  lisp_eval_depth--;
Value returned is $38 =3D (union Lisp_X *) 0x0
(gdb) p args[0]
$39 =3D XIL(0x1401750)
(gdb) xsymbol=20
$40 =3D (struct Lisp_Symbol *) 0x555557199570
"network-stream-get-response"
(gdb) xbacktrace=20
"network-stream-get-response" (0xffffb778)
"network-stream-open-starttls" (0xffffbc28)
"open-network-stream" (0xffffbf10)
"nntp-open-connection" (0xffffc3f0)
"nntp-possibly-change-group" (0xffffcaa0)
"nntp-with-open-group-function" (0xffffcd40)
"nntp-request-article" (0xffffcfb0)
"gnus-request-article" (0xffffd278)
"gnus-async-prefetch-article" (0xffffd588)
"apply" (0xffffd698)
"timer-event-handler" (0xffffd948)

So this looks very similar to the first one.

(gdb) finish
Run till exit from #0  Ffuncall (nargs=3D4, args=3Dargs@entry=3D0x7fffffffb=
770)
    at eval.c:2826
0x0000555555721250 in exec_byte_code (bytestr=3D<optimized out>,=20
    vector=3D<optimized out>, maxdepth=3D<optimized out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D5, args=3D<optim=
ized out>,=20
    args@entry=3D0x30) at bytecode.c:633
633		    TOP =3D Ffuncall (op + 1, &TOP);
Value returned is $41 =3D (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  0x0000555555721250 in exec_byte_code (
    bytestr=3D<optimized out>, vector=3D<optimized out>, maxdepth=3D<optimi=
zed out>,=20
    args_template=3D<optimized out>, nargs=3Dnargs@entry=3D5, args=3D<optim=
ized out>,=20
    args@entry=3D0x30) at bytecode.c:633
Ffuncall (nargs=3D2, args=3Dargs@entry=3D0x7fffffffbbd8) at eval.c:2826
2826	  lisp_eval_depth--;
Value returned is $42 =3D (union Lisp_X *) 0x555559d0a544
(gdb) cont
Continuing.

And upon continuing, Emacs un-stuck with the following message:

Error running timer =E2=80=98gnus-async-prefetch-article=E2=80=99: (error "=
Server closed connection")


--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 25 Jun 2019 19:15:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 25 15:15:29 2019
Received: from localhost ([127.0.0.1]:33555 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hfque-0000Gv-07
	for submit <at> debbugs.gnu.org; Tue, 25 Jun 2019 15:15:29 -0400
Received: from quimby.gnus.org ([80.91.231.51]:54922)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hfqub-0000Gj-AB
 for 24201 <at> debbugs.gnu.org; Tue, 25 Jun 2019 15:15:26 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hfquT-0003Ql-Kl; Tue, 25 Jun 2019 21:15:21 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN> <m3y31qn246.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAD1BMVEU1FE1lOW4mCUNMJVul
 brQHWCMmAAACTUlEQVQ4jW1TgZHcIAwUKAWAoQAsUoBALiB83H9NWWH/z/9MfDe2T4tW0q6ORr7/
 exHl91q1/gA0lJLHg/0AEuWSrWSA40l57hSIQzJDvNgTyvfCC7EZ45MGECdzcO3izGTEiUdJT4d1
 5V2cVAfhEQrp8ON1pxFrSKxEod7KuK1cX6rESRMFZ1atfh5kpRKKJCJwrOtePLIDaGOQNH0G8Iop
 uAQZI2dqhV+58rxWGEXHloBODS+QhG9oYJjWAZ/vAY4GxmJzZLvTRZb0BWb3UoFZeSUGFTtrwRjk
 wB+0OWoy6sxp+ID3ehL5CBY0UwiNVSg2y5/NZar5ovOMGkmjSAtb9r+qNgBYU5LhgEjgzRWNc6UZ
 24TuG2i7/MdJGI0odpSWndK2UuuwHAvNroyQkQPjtbvA8aQqOK1O1lJ1O/52SkI8teEw776yRYy/
 ODahc3JwYGeYMqosamjotP4LIUYDMK1dXsRGxH5EU2/0ufhxcBxwUFr8isNj12Wpj8Ei34CtWKIR
 /ZB85/IUuIhyetpnTkMDcG1hDSY6O7tPCCQ6xJDWOgPg8K0MMFZsgffegnKc7YmCgAEVvEdh+IS9
 a5sq4hnKwDvssckkcVPBY6GwclIf0BU/eUZIJ/hikY0mYYbC1/wt28N9XUtlQnap+COf9zGfcBTs
 L5hbipy9tERtUzqEC4mQARP42QQsiYVa3DT4RFF7cE2E2vlRuRRpPfEBOdHT8VmY9p19GPIf7Qm/
 1aXNeU4faZ+L7avdnmaf2OboLQJo0RkxZj9A8w/nDo/m8ZWbrQAAAABJRU5ErkJggg==
Date: Tue, 25 Jun 2019 21:15:17 +0200
In-Reply-To: <m3y31qn246.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Mon,
 24 Jun 2019 22:46:01 +0200")
Message-ID: <m38stpzdbu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Lars Ingebrigtsen <larsi@HIDDEN> writes: >> Ffuncall
 (nargs=4, 
 args=args@entry=0x7fffffffb420) at eval.c:2826 >> 2826 lisp_eval_depth--;
 >> Value returned is $12 = (union Lisp_X *) 0x0 >> >> don't type "finish",
 but instead do this: >> >> (g [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

>>   Ffuncall (nargs=4, args=args@entry=0x7fffffffb420) at eval.c:2826
>>   2826	  lisp_eval_depth--;
>>   Value returned is $12 = (union Lisp_X *) 0x0
>>
>> don't type "finish", but instead do this:
>>
>>   (gdb) p args[0]
>>   (gdb) xsymbol

It's frustrating -- when running under gdb, this hang seems to happen a
lot less often, and it hasn't happen against since last time.  But I was
just looking at the code to try to understand the previous backtrace.

So, the "finish" stuff seemed to show that we weren't hanging in
accept-process-output at all, but were instead just calling functions as
normal, and looping on the Lisp level?  And, for instance, Ffuncall has
a maybe_quit, so C-g should work in these instances?  But they don't,
which is confusing.

Is it even possible for the Lisp-ier functions in the backtrace to
inhibit C-g?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 24 Jun 2019 20:46:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 24 16:46:07 2019
Received: from localhost ([127.0.0.1]:58154 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hfVqp-00049f-GS
	for submit <at> debbugs.gnu.org; Mon, 24 Jun 2019 16:46:07 -0400
Received: from quimby.gnus.org ([80.91.231.51]:36388)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hfVqn-00049X-N0
 for 24201 <at> debbugs.gnu.org; Mon, 24 Jun 2019 16:46:06 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hfVqj-0007aU-Qc; Mon, 24 Jun 2019 22:46:04 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
 <834l4en63b.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAElBMVEVVdZEXHjVZ0OYpMUpl
 j6xBUWsL3gelAAACPklEQVQ4jVWUsXbrIAyGVQJ7CTc7lc0erLLn+JCdgnn/V6mEHTdXnqJP0i8J
 CKTORqmX3lLp/MvAAx46w09q0VnXNygmG216K1qboiH1RmRvveAS0KPptMGjc1brLVpLdA/L19rR
 GCr62TpA782y3fw9qGISEbEc9S6l2O/83UC5WEeWGtMEcB8Jmv0Q2R9pWNdAxL9VATCSyMAdILpo
 NzDQ7OhBLIkEUELg8Mh+F0c0NZ4XIFX0RD92FHJWNKSpB9B6RQWTgDgyxo5KhhQqInqOPyT6AeLE
 flSW4qtTHrBDBhsErLvsDriZzMAPYCm1MwM0r91BfYE2xKUUCHiqHfCO2rsGeZxZnGeQgaVbKFxs
 aARQwBlOJmiizQtlgMEXI6Fj2WY0JRpWYSjm2faBJRg0+2ewCzZHF/aCKTBGyI+cEex1drRHi7FP
 bGXAti+OS4z4rDlBQF02bZIZmzgSdrB8hxA4gTeR8xtwVxPmKiInWXFk/Jvmuj2HvD79Am6TWia/
 y+9gZFB0fjG+Gun3PYP3ydd53UKHA8x/IPn6nF8Zw70DdcHNK7P75xP0VqfV4Lfnyf8SBPQl1KAM
 vksLSKl6/oLy+jX1AHw+31j4q/P/QC4l8hPj72j3DxBecFJnrVVuxwGmGhZf5T08Xkn8vqxdv65+
 1DvBPA9QwydGruaPM8/jzNmuM+EHV0P5w4DzaBmgxWlBwud+02XIARb8qSxyUf5Y5Ev8hh9Xjg/1
 bRTI/C4dfn1iYwn0g8i6fgEmpsN4L1MvjgAAAABJRU5ErkJggg==
Date: Mon, 24 Jun 2019 22:46:01 +0200
In-Reply-To: <834l4en63b.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 24 Jun
 2019 22:20:08 +0300")
Message-ID: <m3y31qn246.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > Each time "finish"
 doesn't return you have a call to funcall and 2 > calls to exec_byte_code
 above it. Can you tell what function is being > called by funcall? It's easy:
 after you get to that frame [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Each time "finish" doesn't return you have a call to funcall and 2
> calls to exec_byte_code above it.  Can you tell what function is being
> called by funcall?  It's easy: after you get to that frame, and see
> this:
>
>   Ffuncall (nargs=4, args=args@entry=0x7fffffffb420) at eval.c:2826
>   2826	  lisp_eval_depth--;
>   Value returned is $12 = (union Lisp_X *) 0x0
>
> don't type "finish", but instead do this:
>
>   (gdb) p args[0]
>   (gdb) xsymbol

[...]

> Once you see the name of that function, look at its caller's code, and
> try to figure out what are the two levels of exec_byte_code above
> Ffuncall doing, and through this why they might loop.

Ah, OK, I'll try that the next time this happens.

Thanks; I'm a total novice at using gdb to debug Emacs...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 24 Jun 2019 19:20:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 24 15:20:31 2019
Received: from localhost ([127.0.0.1]:58004 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hfUVz-0003la-2m
	for submit <at> debbugs.gnu.org; Mon, 24 Jun 2019 15:20:31 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39948)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hfUVx-0003lL-2H
 for 24201 <at> debbugs.gnu.org; Mon, 24 Jun 2019 15:20:29 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42553)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hfUVr-00045F-Df; Mon, 24 Jun 2019 15:20:23 -0400
Received: from [176.228.60.248] (port=1603 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hfUVp-00049k-9d; Mon, 24 Jun 2019 15:20:23 -0400
Date: Mon, 24 Jun 2019 22:20:08 +0300
Message-Id: <834l4en63b.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3blynxggv.fsf@HIDDEN> (message from Lars Ingebrigtsen on Mon, 
 24 Jun 2019 15:25:52 +0200)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN> <m3blynxggv.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Mon, 24 Jun 2019 15:25:52 +0200
> 
> I've now started looking at this again, and is running Emacs under gdb.

Thanks.

> Last night, I got the hang again.  I C-z'd in gdb (i.e., SIGTSTP), and
> then did "finish" until it returned sufficiently that we got back to the
> hang, and the I repeated, the procedure a couple of times, until the
> file "finish" returned to Emacs and Emacs was un-hung.
> 
> These hangs usually last for about a minute or so, with intervention
> with gdb or not, so I would guess that the code stops hanging when the
> peer finally gives up on the connection and hangs up or something.
> 
> Does the output from gdb have any smoking gun about what's making this
> semi-infloop in accept-process-output?

It doesn't loop in accept-process-output, it loops several stack
frames above that.  accept-process-output returns when you type
"finish", so it by itself is not the culprit.

> (gdb) finish
> Run till exit from #0  Ffuncall (nargs=4, args=args@entry=0x7fffffffb420)
>     at eval.c:2826
> 0x0000555555720e60 in exec_byte_code (bytestr=<optimized out>, 
>     vector=<optimized out>, maxdepth=<optimized out>, 
>     args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
>     args@entry=0x34) at bytecode.c:633
> 633		    TOP = Ffuncall (op + 1, &TOP);
> Value returned is $13 = (union Lisp_X *) 0x0
> (gdb) finish
> Run till exit from #0  0x0000555555720e60 in exec_byte_code (
>     bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
>     args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
>     args@entry=0x34) at bytecode.c:633
> 
> ^Z

Each time "finish" doesn't return you have a call to funcall and 2
calls to exec_byte_code above it.  Can you tell what function is being
called by funcall?  It's easy: after you get to that frame, and see
this:

  Ffuncall (nargs=4, args=args@entry=0x7fffffffb420) at eval.c:2826
  2826	  lisp_eval_depth--;
  Value returned is $12 = (union Lisp_X *) 0x0

don't type "finish", but instead do this:

  (gdb) p args[0]
  (gdb) xsymbol

You should see one of the Lisp functions you see in the Lisp
backtrace:

  "accept-process-output" (0xffffb498)
  "network-stream-get-response" (0xffffb728)
  "network-stream-open-starttls" (0xffffbbd8)
  "open-network-stream" (0xffffbec0)
  "nntp-open-connection" (0xffffc3a0)
  "nntp-possibly-change-group" (0xffffca50)
  "nntp-with-open-group-function" (0xffffccf0)
  "nntp-request-article" (0xffffcf60)
  "gnus-request-article" (0xffffd228)
  "gnus-async-prefetch-article" (0xffffd538)
  "apply" (0xffffd648)
  "timer-event-handler" (0xffffd8f8)

Once you see the name of that function, look at its caller's code, and
try to figure out what are the two levels of exec_byte_code above
Ffuncall doing, and through this why they might loop.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 24 Jun 2019 13:26:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 24 09:26:03 2019
Received: from localhost ([127.0.0.1]:55813 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hfOyw-0007X9-Ku
	for submit <at> debbugs.gnu.org; Mon, 24 Jun 2019 09:26:03 -0400
Received: from quimby.gnus.org ([80.91.231.51]:58028)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hfOyu-0007Wt-Ch
 for 24201 <at> debbugs.gnu.org; Mon, 24 Jun 2019 09:26:01 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=stories)
 by quimby.gnus.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.89)
 (envelope-from <larsi@HIDDEN>)
 id 1hfOym-0003Kt-PW; Mon, 24 Jun 2019 15:25:55 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
 <m3woz8d89h.fsf@HIDDEN>
Date: Mon, 24 Jun 2019 15:25:52 +0200
In-Reply-To: <m3woz8d89h.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Mon,
 19 Feb 2018 21:39:06 +0100")
Message-ID: <m3blynxggv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  I've now started looking at this again, and is running Emacs
 under gdb. Last night, I got the hang again. I C-z'd in gdb (i.e., SIGTSTP),
 and then did "finish" until it returned sufficiently that we got back to
 the hang, and the I repeated, the procedure a couple of times [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I've now started looking at this again, and is running Emacs under gdb.

Last night, I got the hang again.  I C-z'd in gdb (i.e., SIGTSTP), and
then did "finish" until it returned sufficiently that we got back to the
hang, and the I repeated, the procedure a couple of times, until the
file "finish" returned to Emacs and Emacs was un-hung.

These hangs usually last for about a minute or so, with intervention
with gdb or not, so I would guess that the code stops hanging when the
peer finally gives up on the connection and hangs up or something.

Does the output from gdb have any smoking gun about what's making this
semi-infloop in accept-process-output?

(In case nobody remembers what this bug report is about: Sometimes, in
rare circumstances (like once every other day), when opening a TLS
connection from a timer (or probably any other asynchronous context),
and there's other TLS traffic already in happening, opening a new TLS
connection will hang.  I have no repeatable test case, though.)

Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
pthread_sigmask (how=how@entry=0, newmask=<optimized out>, 
    newmask@entry=0x7fffffffa500, oldmask=oldmask@entry=0x7fffffffa5a0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
50	../sysdeps/unix/sysv/linux/pthread_sigmask.c: No such file or directory.
(gdb) xbacktrace 
"accept-process-output" (0xffffb198)
"network-stream-get-response" (0xffffb428)
"network-stream-open-starttls" (0xffffb8d8)
"open-network-stream" (0xffffbbc0)
"nntp-open-connection" (0xffffc0a0)
"nntp-open-server" (0xffffc3a0)
"nntp-possibly-change-group" (0xffffca50)
"nntp-with-open-group-function" (0xffffccf0)
"nntp-request-article" (0xffffcf60)
"gnus-request-article" (0xffffd228)
"gnus-async-prefetch-article" (0xffffd538)
"apply" (0xffffd648)
"timer-event-handler" (0xffffd8f8)
(gdb) bt
#0  pthread_sigmask (how=how@entry=0, newmask=<optimized out>, 
    newmask@entry=0x7fffffffa500, oldmask=oldmask@entry=0x7fffffffa5a0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
#1  0x00005555556858be in block_interrupt_signal (
    oldset=oldset@entry=0x7fffffffa5a0) at sysdep.c:873
#2  0x000055555574cbed in really_call_select (arg=0x7fffffffa640)
    at thread.c:581
#3  0x000055555574d1d9 in thread_select (func=<optimized out>, 
    max_fds=max_fds@entry=23, rfds=rfds@entry=0x7fffffffa710, 
    wfds=wfds@entry=0x7fffffffa790, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffad60, sigmask=0x0) at thread.c:616
#4  0x000055555576aa75 in xg_select (fds_lim=23, 
    rfds=rfds@entry=0x7fffffffae90, wfds=wfds@entry=0x7fffffffaf10, 
    efds=efds@entry=0x0, timeout=timeout@entry=0x7fffffffad60, 
    sigmask=sigmask@entry=0x0) at xgselect.c:117
#5  0x000055555572bb97 in wait_reading_process_output (
    time_limit=<optimized out>, nsecs=<optimized out>, 
    read_kbd=read_kbd@entry=0, do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), 
    wait_proc=wait_proc@entry=0x555556830280, just_wait_proc=0)
    at process.c:5427
#6  0x000055555572d45b in Faccept_process_output (process=XIL(0x555556830285), 
    seconds=<optimized out>, millisec=<optimized out>, 
---Type <return> to continue, or q <return> to quit---q
just_this_one=<optimized Quit
(gdb) finish
Run till exit from #0  pthread_sigmask (how=how@entry=0, 
    newmask=<optimized out>, newmask@entry=0x7fffffffa500, 
    oldmask=oldmask@entry=0x7fffffffa5a0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
block_interrupt_signal (oldset=oldset@entry=0x7fffffffa5a0) at sysdep.c:874
warning: Source file is more recent than executable.
874	  pthread_sigmask (SIG_SETMASK, oldset, 0);
Value returned is $6 = 0
(gdb) finish
Run till exit from #0  block_interrupt_signal (
    oldset=oldset@entry=0x7fffffffa5a0) at sysdep.c:874
really_call_select (arg=0x7fffffffa640) at thread.c:583
583	  release_global_lock ();
(gdb) finish
Run till exit from #0  really_call_select (arg=0x7fffffffa640) at thread.c:583
thread_select (func=<optimized out>, max_fds=max_fds@entry=23, 
    rfds=rfds@entry=0x7fffffffa710, wfds=wfds@entry=0x7fffffffa790, 
    efds=efds@entry=0x0, timeout=timeout@entry=0x7fffffffad60, sigmask=0x0)
    at thread.c:618
618	}
(gdb) finish
Run till exit from #0  thread_select (func=<optimized out>, 
    max_fds=max_fds@entry=23, rfds=rfds@entry=0x7fffffffa710, 
    wfds=wfds@entry=0x7fffffffa790, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffad60, sigmask=0x0) at thread.c:618
xg_select (fds_lim=23, rfds=rfds@entry=0x7fffffffae90, 
    wfds=wfds@entry=0x7fffffffaf10, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffad60, sigmask=sigmask@entry=0x0)
    at xgselect.c:120
120	  if (nfds < 0)
Value returned is $7 = 3
(gdb) finish
Run till exit from #0  xg_select (fds_lim=23, rfds=rfds@entry=0x7fffffffae90, 
    wfds=wfds@entry=0x7fffffffaf10, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffad60, sigmask=sigmask@entry=0x0)
    at xgselect.c:120
wait_reading_process_output (time_limit=<optimized out>, 
    nsecs=<optimized out>, read_kbd=read_kbd@entry=0, 
    do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), 
    wait_proc=wait_proc@entry=0x555556830280, just_wait_proc=0)
    at process.c:5447
5447	          if (nfds == 0)
Value returned is $8 = 2
(gdb) finish
Run till exit from #0  wait_reading_process_output (
    time_limit=<optimized out>, nsecs=<optimized out>, 
    read_kbd=read_kbd@entry=0, do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), 
    wait_proc=wait_proc@entry=0x555556830280, just_wait_proc=0)
    at process.c:5447
Faccept_process_output (process=XIL(0x555556830285), seconds=<optimized out>, 
    millisec=<optimized out>, just_this_one=<optimized out>) at process.c:4715
4715	     ? Qnil : Qt);
Value returned is $9 = 74
(gdb) finish
Run till exit from #0  Faccept_process_output (process=XIL(0x555556830285), 
    seconds=<optimized out>, millisec=<optimized out>, 
    just_this_one=<optimized out>) at process.c:4715
0x00005555556ea3d9 in Ffuncall (nargs=3, args=args@entry=0x7fffffffb190)
    at eval.c:2803
2803	    val = funcall_subr (XSUBR (fun), numargs, args + 1);
Value returned is $10 = (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x00005555556ea3d9 in Ffuncall (nargs=3, 
    args=args@entry=0x7fffffffb190) at eval.c:2803
0x0000555555720e60 in exec_byte_code (bytestr=<optimized out>, 
    vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=3, args=<optimized out>, 
    args@entry=0x35) at bytecode.c:633
warning: Source file is more recent than executable.
633		    TOP = Ffuncall (op + 1, &TOP);
Value returned is $11 = (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x0000555555720e60 in exec_byte_code (
    bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=3, args=<optimized out>, 
    args@entry=0x35) at bytecode.c:633
Ffuncall (nargs=4, args=args@entry=0x7fffffffb420) at eval.c:2826
2826	  lisp_eval_depth--;
Value returned is $12 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  Ffuncall (nargs=4, args=args@entry=0x7fffffffb420)
    at eval.c:2826
0x0000555555720e60 in exec_byte_code (bytestr=<optimized out>, 
    vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
    args@entry=0x34) at bytecode.c:633
633		    TOP = Ffuncall (op + 1, &TOP);
Value returned is $13 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  0x0000555555720e60 in exec_byte_code (
    bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
    args@entry=0x34) at bytecode.c:633

^Z
Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
pthread_sigmask (how=how@entry=0, newmask=<optimized out>, 
    newmask@entry=0x7fffffffa800, oldmask=oldmask@entry=0x7fffffffa8a0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
50	../sysdeps/unix/sysv/linux/pthread_sigmask.c: No such file or directory.
(gdb) xbacktrace 
"accept-process-output" (0xffffb498)
"network-stream-get-response" (0xffffb728)
"network-stream-open-starttls" (0xffffbbd8)
"open-network-stream" (0xffffbec0)
"nntp-open-connection" (0xffffc3a0)
"nntp-possibly-change-group" (0xffffca50)
"nntp-with-open-group-function" (0xffffccf0)
"nntp-request-article" (0xffffcf60)
"gnus-request-article" (0xffffd228)
"gnus-async-prefetch-article" (0xffffd538)
"apply" (0xffffd648)
"timer-event-handler" (0xffffd8f8)
(gdb) finish
Run till exit from #0  pthread_sigmask (how=how@entry=0, 
    newmask=<optimized out>, newmask@entry=0x7fffffffa800, 
    oldmask=oldmask@entry=0x7fffffffa8a0)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
block_interrupt_signal (oldset=oldset@entry=0x7fffffffa8a0) at sysdep.c:874
874	  pthread_sigmask (SIG_SETMASK, oldset, 0);
Value returned is $14 = 0
(gdb) finish
Run till exit from #0  block_interrupt_signal (
    oldset=oldset@entry=0x7fffffffa8a0) at sysdep.c:874
really_call_select (arg=0x7fffffffa940) at thread.c:583
583	  release_global_lock ();
(gdb) finish
Run till exit from #0  really_call_select (arg=0x7fffffffa940) at thread.c:583
thread_select (func=<optimized out>, max_fds=max_fds@entry=23, 
    rfds=rfds@entry=0x7fffffffaa10, wfds=wfds@entry=0x7fffffffaa90, 
    efds=efds@entry=0x0, timeout=timeout@entry=0x7fffffffb060, sigmask=0x0)
    at thread.c:618
618	}
(gdb) finish
Run till exit from #0  thread_select (func=<optimized out>, 
    max_fds=max_fds@entry=23, rfds=rfds@entry=0x7fffffffaa10, 
    wfds=wfds@entry=0x7fffffffaa90, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffb060, sigmask=0x0) at thread.c:618
xg_select (fds_lim=23, rfds=rfds@entry=0x7fffffffb190, 
    wfds=wfds@entry=0x7fffffffb210, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffb060, sigmask=sigmask@entry=0x0)
    at xgselect.c:120
120	  if (nfds < 0)
Value returned is $15 = 3
(gdb) finish
Run till exit from #0  xg_select (fds_lim=23, rfds=rfds@entry=0x7fffffffb190, 
    wfds=wfds@entry=0x7fffffffb210, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffb060, sigmask=sigmask@entry=0x0)
    at xgselect.c:120
wait_reading_process_output (time_limit=<optimized out>, 
    nsecs=<optimized out>, read_kbd=read_kbd@entry=0, 
    do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), 
    wait_proc=wait_proc@entry=0x55555b23b750, just_wait_proc=0)
    at process.c:5447
5447	          if (nfds == 0)
Value returned is $16 = 2
(gdb) finish
Run till exit from #0  wait_reading_process_output (
    time_limit=<optimized out>, nsecs=<optimized out>, 
    read_kbd=read_kbd@entry=0, do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), 
    wait_proc=wait_proc@entry=0x55555b23b750, just_wait_proc=0)
    at process.c:5447
Faccept_process_output (process=XIL(0x55555b23b755), seconds=<optimized out>, 
    millisec=<optimized out>, just_this_one=<optimized out>) at process.c:4715
4715	     ? Qnil : Qt);
Value returned is $17 = 74
(gdb) finish
Run till exit from #0  Faccept_process_output (process=XIL(0x55555b23b755), 
    seconds=<optimized out>, millisec=<optimized out>, 
    just_this_one=<optimized out>) at process.c:4715
0x00005555556ea3d9 in Ffuncall (nargs=3, args=args@entry=0x7fffffffb490)
    at eval.c:2803
2803	    val = funcall_subr (XSUBR (fun), numargs, args + 1);
Value returned is $18 = (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x00005555556ea3d9 in Ffuncall (nargs=3, 
    args=args@entry=0x7fffffffb490) at eval.c:2803
0x0000555555720e60 in exec_byte_code (bytestr=<optimized out>, 
    vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=3, args=<optimized out>, 
    args@entry=0x31) at bytecode.c:633
633		    TOP = Ffuncall (op + 1, &TOP);
Value returned is $19 = (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x0000555555720e60 in exec_byte_code (
    bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=3, args=<optimized out>, 
    args@entry=0x31) at bytecode.c:633
Ffuncall (nargs=4, args=args@entry=0x7fffffffb720) at eval.c:2826
2826	  lisp_eval_depth--;
Value returned is $20 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  Ffuncall (nargs=4, args=args@entry=0x7fffffffb720)
    at eval.c:2826
0x0000555555720e60 in exec_byte_code (bytestr=<optimized out>, 
    vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
    args@entry=0x30) at bytecode.c:633
633		    TOP = Ffuncall (op + 1, &TOP);
Value returned is $21 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  0x0000555555720e60 in exec_byte_code (
    bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
    args@entry=0x30) at bytecode.c:633

^Z
Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
0x00005555556c6c53 in vectorlike_nbytes (hdr=0x555556d1dd20) at alloc.c:2964
2964	  ptrdiff_t size = hdr->size & ~ARRAY_MARK_FLAG;
(gdb) finish
Run till exit from #0  0x00005555556c6c53 in vectorlike_nbytes (
    hdr=0x555556d1dd20) at alloc.c:2964
sweep_vectors () at alloc.c:3073
3073		      gcstat.total_vector_slots += nbytes / word_size;
Value returned is $22 = 1040
(gdb) finish
Run till exit from #0  sweep_vectors () at alloc.c:3073
gc_sweep () at alloc.c:6973
6973	  pdumper_clear_marks ();
(gdb) finish
Run till exit from #0  gc_sweep () at alloc.c:6973
garbage_collect_1 (gcst=0x7fffffffaa30) at alloc.c:5917
5917	  unmark_main_thread ();
(gdb) finish
Run till exit from #0  garbage_collect_1 (gcst=0x7fffffffaa30) at alloc.c:5917
garbage_collect () at alloc.c:5990
5990	}
Value returned is $23 = true
(gdb) finish
Run till exit from #0  garbage_collect () at alloc.c:5990
Ffuncall (nargs=nargs@entry=2, args=args@entry=0x7fffffffab20) at eval.c:2789
2789	  if (debug_on_next_call)
(gdb) finish
Run till exit from #0  Ffuncall (nargs=nargs@entry=2, 
    args=args@entry=0x7fffffffab20) at eval.c:2789
call1 (fn=fn@entry=XIL(0xc960), arg1=arg1@entry=XIL(0x5555570ee915))
    at eval.c:2657
2657	}
Value returned is $24 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  call1 (fn=fn@entry=XIL(0xc960), 
    arg1=arg1@entry=XIL(0x5555570ee915)) at eval.c:2657
timer_check_2 (idle_timers=XIL(0), timers=XIL(0x555571081263))
    at keyboard.c:4309
4309		      unbind_to (count, Qnil);
Value returned is $25 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  timer_check_2 (idle_timers=XIL(0), 
    timers=XIL(0x555571081263)) at keyboard.c:4309
timer_check () at keyboard.c:4368
4368	      nexttime = timer_check_2 (timers, idle_timers);
(gdb) finish
Run till exit from #0  timer_check () at keyboard.c:4368
0x0000555555673bf9 in readable_events (flags=flags@entry=1) at keyboard.c:3367
3367	    timer_check ();
Value returned is $26 = {tv_sec = 0, tv_nsec = 58418057}
(gdb) finish
Run till exit from #0  0x0000555555673bf9 in readable_events (
    flags=flags@entry=1) at keyboard.c:3367
0x0000555555674638 in get_input_pending (flags=flags@entry=1)
    at keyboard.c:6769
6769	  input_pending = (!NILP (Vquit_flag) || readable_events (flags));
Value returned is $27 = true
(gdb) finish
Run till exit from #0  0x0000555555674638 in get_input_pending (
    flags=flags@entry=1) at keyboard.c:6769
swallow_events (do_display=do_display@entry=false) at keyboard.c:4115
4115	  if (!input_pending && timers_run != old_timers_run && do_display)
Value returned is $28 = true
(gdb) finish
Run till exit from #0  swallow_events (do_display=do_display@entry=false)
    at keyboard.c:4115
wait_reading_process_output (time_limit=<optimized out>, 
    nsecs=<optimized out>, read_kbd=read_kbd@entry=0, 
    do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), 
    wait_proc=wait_proc@entry=0x555556853170, just_wait_proc=0)
    at process.c:5605
5605	      if (! NILP (wait_for_cell) && ! NILP (XCAR (wait_for_cell)))
(gdb) finish
Run till exit from #0  wait_reading_process_output (
    time_limit=<optimized out>, nsecs=<optimized out>, 
    read_kbd=read_kbd@entry=0, do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), 
    wait_proc=wait_proc@entry=0x555556853170, just_wait_proc=0)
    at process.c:5605
Faccept_process_output (process=XIL(0x555556853175), seconds=<optimized out>, 
    millisec=<optimized out>, just_this_one=<optimized out>) at process.c:4715
4715	     ? Qnil : Qt);
Value returned is $29 = 74
(gdb) finish
Run till exit from #0  Faccept_process_output (process=XIL(0x555556853175), 
    seconds=<optimized out>, millisec=<optimized out>, 
    just_this_one=<optimized out>) at process.c:4715
0x00005555556ea3d9 in Ffuncall (nargs=3, args=args@entry=0x7fffffffb190)
    at eval.c:2803
2803	    val = funcall_subr (XSUBR (fun), numargs, args + 1);
Value returned is $30 = (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x00005555556ea3d9 in Ffuncall (nargs=3, 
    args=args@entry=0x7fffffffb190) at eval.c:2803
0x0000555555720e60 in exec_byte_code (bytestr=<optimized out>, 
    vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=3, args=<optimized out>, 
    args@entry=0x35) at bytecode.c:633
633		    TOP = Ffuncall (op + 1, &TOP);
Value returned is $31 = (union Lisp_X *) 0xc5a0
(gdb) finish
Run till exit from #0  0x0000555555720e60 in exec_byte_code (
    bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=3, args=<optimized out>, 
    args@entry=0x35) at bytecode.c:633
Ffuncall (nargs=4, args=args@entry=0x7fffffffb420) at eval.c:2826
2826	  lisp_eval_depth--;
Value returned is $32 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  Ffuncall (nargs=4, args=args@entry=0x7fffffffb420)
    at eval.c:2826
0x0000555555720e60 in exec_byte_code (bytestr=<optimized out>, 
    vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
    args@entry=0x34) at bytecode.c:633
633		    TOP = Ffuncall (op + 1, &TOP);
Value returned is $33 = (union Lisp_X *) 0x0
(gdb) finish
Run till exit from #0  0x0000555555720e60 in exec_byte_code (
    bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, 
    args_template=<optimized out>, nargs=nargs@entry=5, args=<optimized out>, 
    args@entry=0x34) at bytecode.c:633

^Z
Thread 1 "emacs" received signal SIGTSTP, Stopped (user).
0x00005555556ca268 in mark_object (arg=<optimized out>) at alloc.c:6571
6571		if (NILP (ptr->u.s.u.cdr))
(gdb) 



-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 20:39:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 15:39:12 2018
Received: from localhost ([127.0.0.1]:51707 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ensDQ-0001hy-FL
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 15:39:12 -0500
Received: from hermes.netfonds.no ([80.91.224.195]:43178)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1ensDO-0001hp-IC
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 15:39:11 -0500
Received: from cm-84.209.240.67.getinternet.no ([84.209.240.67] helo=stories)
 by hermes.netfonds.no with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1ensDK-0000xi-LG; Mon, 19 Feb 2018 21:39:08 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
 <m31shger3t.fsf@HIDDEN> <83h8qc92hc.fsf@HIDDEN>
Date: Mon, 19 Feb 2018 21:39:06 +0100
In-Reply-To: <83h8qc92hc.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 19 Feb
 2018 21:57:35 +0200")
Message-ID: <m3woz8d89h.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

> The best way is to start typing "finish" until it doesn't return from
> the frame.  See the instructions in etc/DEBUG starting at "If Emacs is
> in an infinite loop".  If something in the instructions is unclear,
> please don't hesitate asking.

Thanks; I'll give it a try (and read the document) the next time this
happens.  :-)  

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 19:57:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 14:57:46 2018
Received: from localhost ([127.0.0.1]:51665 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enrZG-0000YY-U9
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 14:57:46 -0500
Received: from eggs.gnu.org ([208.118.235.92]:47383)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1enrZC-0000YI-3e
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 14:57:41 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1enrZ2-0005eT-3T
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 14:57:32 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,T_RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:37748)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1enrZ1-0005eP-Vm; Mon, 19 Feb 2018 14:57:28 -0500
Received: from [176.228.60.248] (port=2763 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1enrZ1-0004oR-DI; Mon, 19 Feb 2018 14:57:27 -0500
Date: Mon, 19 Feb 2018 21:57:35 +0200
Message-Id: <83h8qc92hc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m31shger3t.fsf@HIDDEN> (message from Lars Ingebrigtsen on Mon, 
 19 Feb 2018 20:06:46 +0100)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN> <m31shger3t.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: eggert@HIDDEN,  24201 <at> debbugs.gnu.org
> Date: Mon, 19 Feb 2018 20:06:46 +0100
> 
> Hm...  actually, I don't know.  I say "cont" and then break it again,
> and it says that it's in a pthread_sigmask call, but I don't know
> whether it's the same one...
> 
> The process has unfortunately exited now, but the next time this
> happens, what's the best way to debug what's going on?  I'm not very
> well versed in gdb usage.

The best way is to start typing "finish" until it doesn't return from
the frame.  See the instructions in etc/DEBUG starting at "If Emacs is
in an infinite loop".  If something in the instructions is unclear,
please don't hesitate asking.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 19:06:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 14:06:59 2018
Received: from localhost ([127.0.0.1]:51643 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enqmB-0007hZ-1U
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 14:06:59 -0500
Received: from hermes.netfonds.no ([80.91.224.195]:42076)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1enqm8-0007hQ-Jz
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 14:06:58 -0500
Received: from cm-84.209.240.67.getinternet.no ([84.209.240.67] helo=stories)
 by hermes.netfonds.no with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1enqly-0004Qn-HA; Mon, 19 Feb 2018 20:06:54 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN> <83o9kk96ez.fsf@HIDDEN>
Date: Mon, 19 Feb 2018 20:06:46 +0100
In-Reply-To: <83o9kk96ez.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 19 Feb
 2018 20:32:36 +0200")
Message-ID: <m31shger3t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

>> It's using 100% CPU, so it's busy-waiting, but every time I stop it,
>> it's in that pthread_sigmask, as far as I'm able to tell...
>
> And if you then say "continue" or "finish", does it exit from the
> pthread_sigmask call?  If not, some other thread is spinning.

Hm...  actually, I don't know.  I say "cont" and then break it again,
and it says that it's in a pthread_sigmask call, but I don't know
whether it's the same one...

The process has unfortunately exited now, but the next time this
happens, what's the best way to debug what's going on?  I'm not very
well versed in gdb usage.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 18:37:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 13:37:16 2018
Received: from localhost ([127.0.0.1]:51609 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enqJM-0006xj-IL
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 13:37:16 -0500
Received: from mail-out.m-online.net ([212.18.0.9]:52780)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whitebox@HIDDEN>) id 1enqJH-0006xV-3r
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 13:37:10 -0500
Received: from frontend01.mail.m-online.net (unknown [192.168.8.182])
 by mail-out.m-online.net (Postfix) with ESMTP id 3zlXXd2N20z1qx92;
 Mon, 19 Feb 2018 19:37:05 +0100 (CET)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.70])
 by mail.m-online.net (Postfix) with ESMTP id 3zlXXd28jlz1qrVX;
 Mon, 19 Feb 2018 19:37:05 +0100 (CET)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.182])
 by localhost (dynscan1.mail.m-online.net [192.168.6.70]) (amavisd-new,
 port 10024)
 with ESMTP id dMCuTQNLtuhK; Mon, 19 Feb 2018 19:37:01 +0100 (CET)
X-Auth-Info: cWZXpgiBrYETWLen3xeMIpAk6f8joSo7RUrZCEE83AIwOY2gYUUz9p8QT4iN84rr
Received: from localhost (ppp-188-174-146-66.dynamic.mnet-online.de
 [188.174.146.66])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by mail.mnet-online.de (Postfix) with ESMTPSA;
 Mon, 19 Feb 2018 19:37:01 +0100 (CET)
Received: by localhost (Postfix, from userid 1000)
 id E70BD2C10DA; Mon, 19 Feb 2018 19:37:00 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
 <m3606setf1.fsf@HIDDEN>
X-Yow: ..  the MYSTERIANS are in here with my CORDUROY SOAP DISH!!
Date: Mon, 19 Feb 2018 19:37:00 +0100
In-Reply-To: <m3606setf1.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Mon,
 19 Feb 2018 19:16:50 +0100")
Message-ID: <87606seshf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.91 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On Feb 19 2018, Lars Ingebrigtsen <larsi@HIDDEN> wrote:

> Paul Eggert <eggert@HIDDEN> writes:
>
>> Lars Ingebrigtsen wrote:
>>> #0  pthread_sigmask (how=0, newmask=<optimized out>, oldmask=0x7fffffff8a60)
>>>      at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
>>
>> When you say that Emacs "hangs" surely you don't mean that the call to
>> pthread_sigmask is hanging. So, can we assume that Emacs is
>> busy-waiting for something? Is the CPU pegged? What does the busy-wait
>> loop look like?
>
> It's using 100% CPU, so it's busy-waiting, but every time I stop it,
> it's in that pthread_sigmask, as far as I'm able to tell...

Since it's making a syscall the loop is likely spending a significant
part of the time there.  That doesn't mean it's reponsible for the busy
wait.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 18:32:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 13:32:44 2018
Received: from localhost ([127.0.0.1]:51601 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enqEz-0006qw-FH
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 13:32:44 -0500
Received: from eggs.gnu.org ([208.118.235.92]:56205)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1enqEv-0006qh-KD
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 13:32:41 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1enqEm-0000v1-Eq
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 13:32:32 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,T_RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:36350)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1enqEm-0000uu-Bn; Mon, 19 Feb 2018 13:32:28 -0500
Received: from [176.228.60.248] (port=2715 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1enqEl-0001XF-OJ; Mon, 19 Feb 2018 13:32:28 -0500
Date: Mon, 19 Feb 2018 20:32:36 +0200
Message-Id: <83o9kk96ez.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3606setf1.fsf@HIDDEN> (message from Lars Ingebrigtsen on Mon, 
 19 Feb 2018 19:16:50 +0100)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN> <m3606setf1.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  24201 <at> debbugs.gnu.org
> Date: Mon, 19 Feb 2018 19:16:50 +0100
> 
> Paul Eggert <eggert@HIDDEN> writes:
> 
> > Lars Ingebrigtsen wrote:
> >> #0  pthread_sigmask (how=0, newmask=<optimized out>, oldmask=0x7fffffff8a60)
> >>      at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
> >
> > When you say that Emacs "hangs" surely you don't mean that the call to
> > pthread_sigmask is hanging. So, can we assume that Emacs is
> > busy-waiting for something? Is the CPU pegged? What does the busy-wait
> > loop look like?
> 
> It's using 100% CPU, so it's busy-waiting, but every time I stop it,
> it's in that pthread_sigmask, as far as I'm able to tell...

And if you then say "continue" or "finish", does it exit from the
pthread_sigmask call?  If not, some other thread is spinning.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 18:16:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 13:16:59 2018
Received: from localhost ([127.0.0.1]:51594 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enpzn-0006Tf-1H
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 13:16:59 -0500
Received: from hermes.netfonds.no ([80.91.224.195]:41555)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1enpzk-0006TV-P4
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 13:16:57 -0500
Received: from cm-84.209.240.67.getinternet.no ([84.209.240.67] helo=stories)
 by hermes.netfonds.no with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1enpze-0005XU-U6; Mon, 19 Feb 2018 19:16:55 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Paul Eggert <eggert@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
 <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
Date: Mon, 19 Feb 2018 19:16:50 +0100
In-Reply-To: <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN> (Paul Eggert's
 message of "Mon, 19 Feb 2018 09:56:00 -0800")
Message-ID: <m3606setf1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: Eli Zaretskii <eliz@HIDDEN>, 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Paul Eggert <eggert@HIDDEN> writes:

> Lars Ingebrigtsen wrote:
>> #0  pthread_sigmask (how=0, newmask=<optimized out>, oldmask=0x7fffffff8a60)
>>      at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
>
> When you say that Emacs "hangs" surely you don't mean that the call to
> pthread_sigmask is hanging. So, can we assume that Emacs is
> busy-waiting for something? Is the CPU pegged? What does the busy-wait
> loop look like?

It's using 100% CPU, so it's busy-waiting, but every time I stop it,
it's in that pthread_sigmask, as far as I'm able to tell...

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 17:56:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 12:56:09 2018
Received: from localhost ([127.0.0.1]:51577 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enpfc-0005zY-Tf
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 12:56:09 -0500
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:57304)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1enpfb-0005z6-1z
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 12:56:07 -0500
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 692AC1615B2;
 Mon, 19 Feb 2018 09:56:01 -0800 (PST)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id G5xtVSvdlySD; Mon, 19 Feb 2018 09:56:00 -0800 (PST)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id B58E91615E4;
 Mon, 19 Feb 2018 09:56:00 -0800 (PST)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id DImsE09qFlJj; Mon, 19 Feb 2018 09:56:00 -0800 (PST)
Received: from [192.168.1.9] (unknown [47.154.30.119])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 8F7641615B2;
 Mon, 19 Feb 2018 09:56:00 -0800 (PST)
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
To: Lars Ingebrigtsen <larsi@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN> <83d1j8e9c0.fsf@HIDDEN>
 <83shg5z32d.fsf@HIDDEN> <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN> <m3d110excc.fsf@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
Message-ID: <6e9f3b6c-43df-bf95-d346-56c93c61b4d7@HIDDEN>
Date: Mon, 19 Feb 2018 09:56:00 -0800
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101
 Thunderbird/52.6.0
MIME-Version: 1.0
In-Reply-To: <m3d110excc.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Lars Ingebrigtsen wrote:
> #0  pthread_sigmask (how=0, newmask=<optimized out>, oldmask=0x7fffffff8a60)
>      at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50

When you say that Emacs "hangs" surely you don't mean that the call to 
pthread_sigmask is hanging. So, can we assume that Emacs is busy-waiting for 
something? Is the CPU pegged? What does the busy-wait loop look like?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 19 Feb 2018 16:52:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Feb 19 11:52:11 2018
Received: from localhost ([127.0.0.1]:51514 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enofj-0004A7-B6
	for submit <at> debbugs.gnu.org; Mon, 19 Feb 2018 11:52:11 -0500
Received: from hermes.netfonds.no ([80.91.224.195]:40640)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1enofh-00049t-Bi
 for 24201 <at> debbugs.gnu.org; Mon, 19 Feb 2018 11:52:10 -0500
Received: from cm-84.209.240.67.getinternet.no ([84.209.240.67] helo=stories)
 by hermes.netfonds.no with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1enofc-0000nn-1o; Mon, 19 Feb 2018 17:52:06 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
 <m3r2pikwnu.fsf@HIDDEN>
Date: Mon, 19 Feb 2018 17:52:03 +0100
In-Reply-To: <m3r2pikwnu.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sun,
 18 Feb 2018 18:57:57 +0100")
Message-ID: <m3d110excc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

It seems more difficult to reproduce the bug in a non-optimised build,
but it finally happened:

#0  pthread_sigmask (how=0, newmask=<optimized out>, oldmask=0x7fffffff8a60)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
#1  0x00000000005800ec in block_interrupt_signal (oldset=0x7fffffff8a60) at sysdep.c:843
#2  0x00000000006898fc in really_call_select (arg=0x7fffffff8bb0) at thread.c:575
#3  0x00000000005e08ed in flush_stack_call_func (func=0x689853 <really_call_select>, 
    arg=0x7fffffff8bb0) at alloc.c:5218
#4  0x000000000068999e in thread_select (func=0x7fffefb02420 <__pselect>, max_fds=16, 
    rfds=0x7fffffff90e0, wfds=0x7fffffff9060, efds=0x0, timeout=0x7fffffff9380, 
    sigmask=0x0) at thread.c:602
#5  0x00000000006b2ce1 in xg_select (fds_lim=16, rfds=0x7fffffff9420, 
    wfds=0x7fffffff93a0, efds=0x0, timeout=0x7fffffff9380, sigmask=0x0) at xgselect.c:117
#6  0x000000000065f6c5 in wait_reading_process_output (time_limit=0, nsecs=50000000, 
    read_kbd=0, do_display=false, wait_for_cell=XIL(0), wait_proc=0x150084d0, 
    just_wait_proc=0) at process.c:5379
#7  0x000000000065da81 in Faccept_process_output (process=XIL(0x150084d5), 
    seconds=XIL(0xd44b7f), millisec=make_number(50), just_this_one=XIL(0))
    at process.c:4667
#8  0x00000000006081b1 in funcall_subr (subr=0xc46580 <Saccept_process_output>, 
    numargs=3, args=0x7fffffff9768) at eval.c:2901
#9  0x0000000000607d46 in Ffuncall (nargs=4, args=0x7fffffff9760) at eval.c:2818
#10 0x000000000065096e in exec_byte_code (bytestr=XIL(0x43d1f04), vector=XIL(0x414c3a5), 
    maxdepth=make_number(7), args_template=make_number(771), nargs=3, 
    args=0x7fffffff9cb0) at bytecode.c:632
#11 0x000000000060877c in funcall_lambda (fun=XIL(0x414c3f5), nargs=3, 
    arg_vector=0x7fffffff9c98) at eval.c:3019
#12 0x0000000000607d8a in Ffuncall (nargs=4, args=0x7fffffff9c90) at eval.c:2820
#13 0x000000000065096e in exec_byte_code (bytestr=XIL(0x43d1d04), vector=XIL(0x42e7be5), 
    maxdepth=make_number(28), args_template=make_number(1285), nargs=5, 
    args=0x7fffffffa400) at bytecode.c:632
#14 0x000000000060877c in funcall_lambda (fun=XIL(0x414c325), nargs=5, 
    arg_vector=0x7fffffffa3d8) at eval.c:3019
#15 0x0000000000607d8a in Ffuncall (nargs=6, args=0x7fffffffa3d0) at eval.c:2820
#16 0x000000000065096e in exec_byte_code (bytestr=XIL(0x43d6684), vector=XIL(0x414c015), 
    maxdepth=make_number(22), args_template=make_number(1156), nargs=14, 
    args=0x7fffffffa990) at bytecode.c:632
#17 0x000000000060877c in funcall_lambda (fun=XIL(0x414c175), nargs=14, 
    arg_vector=0x7fffffffa970) at eval.c:3019
#18 0x0000000000607d8a in Ffuncall (nargs=15, args=0x7fffffffa968) at eval.c:2820
#19 0x000000000065096e in exec_byte_code (bytestr=XIL(0x4235df4), vector=XIL(0x42361a5), 
    maxdepth=make_number(15), args_template=XIL(0), nargs=0, args=0x0) at bytecode.c:632
#20 0x0000000000608b04 in funcall_lambda (fun=XIL(0x4235b35), nargs=1, 
    arg_vector=0x42361a5) at eval.c:3101
#21 0x0000000000607d8a in Ffuncall (nargs=2, args=0x7fffffffb088) at eval.c:2820
#22 0x000000000065096e in exec_byte_code (bytestr=XIL(0x4230074), vector=XIL(0x422f5b5), 
    maxdepth=make_number(4), args_template=XIL(0), nargs=0, args=0x0) at bytecode.c:632
#23 0x0000000000608b04 in funcall_lambda (fun=XIL(0x422f685), nargs=3, 
    arg_vector=0x422f5b5) at eval.c:3101
#24 0x0000000000607d8a in Ffuncall (nargs=4, args=0x7fffffffb5b8) at eval.c:2820
#25 0x000000000065096e in exec_byte_code (bytestr=XIL(0x42373c4), vector=XIL(0x4236965), 
    maxdepth=make_number(8), args_template=XIL(0), nargs=0, args=0x0) at bytecode.c:632
#26 0x0000000000608b04 in funcall_lambda (fun=XIL(0x4236cb5), nargs=3, 
    arg_vector=0x4236965) at eval.c:3101
#27 0x0000000000607d8a in Ffuncall (nargs=4, args=0x7fffffffbeb8) at eval.c:2820
#28 0x000000000065096e in exec_byte_code (bytestr=XIL(0x4226f24), vector=XIL(0x4228785), 
    maxdepth=make_number(4), args_template=XIL(0), nargs=0, args=0x0) at bytecode.c:632
#29 0x0000000000608b04 in funcall_lambda (fun=XIL(0x4227ee5), nargs=4, 
    arg_vector=0x4228785) at eval.c:3101
#30 0x0000000000607d8a in Ffuncall (nargs=5, args=0x7fffffffc388) at eval.c:2820
#31 0x000000000065096e in exec_byte_code (bytestr=XIL(0x422e994), vector=XIL(0x422db75), 
    maxdepth=make_number(5), args_template=XIL(0), nargs=0, args=0x0) at bytecode.c:632
#32 0x0000000000608b04 in funcall_lambda (fun=XIL(0x422dba5), nargs=4, 
    arg_vector=0x422db75) at eval.c:3101
#33 0x0000000000607d8a in Ffuncall (nargs=5, args=0x7fffffffc828) at eval.c:2820
#34 0x000000000065096e in exec_byte_code (bytestr=XIL(0x3b09454), vector=XIL(0x3f7ec65), 
    maxdepth=make_number(5), args_template=XIL(0), nargs=0, args=0x0) at bytecode.c:632
#35 0x0000000000608b04 in funcall_lambda (fun=XIL(0x3eef535), nargs=2, 
    arg_vector=0x3f7ec65) at eval.c:3101
#36 0x0000000000607d8a in Ffuncall (nargs=3, args=0x7fffffffcce8) at eval.c:2820
#37 0x000000000065096e in exec_byte_code (bytestr=XIL(0x4e49874), vector=XIL(0x42f70d5), 
    maxdepth=make_number(7), args_template=XIL(0), nargs=0, args=0x0) at bytecode.c:632
#38 0x0000000000608b04 in funcall_lambda (fun=XIL(0x42d4fd5), nargs=3, 
    arg_vector=0x42f70d5) at eval.c:3101
#39 0x0000000000607d8a in Ffuncall (nargs=4, args=0x7fffffffd2a0) at eval.c:2820
#40 0x000000000060716c in Fapply (nargs=2, args=0x7fffffffd488) at eval.c:2438
#41 0x0000000000608049 in funcall_subr (subr=0xc42a00 <Sapply>, numargs=2, 
    args=0x7fffffffd488) at eval.c:2873
#42 0x0000000000607d46 in Ffuncall (nargs=3, args=0x7fffffffd480) at eval.c:2818
#43 0x000000000065096e in exec_byte_code (bytestr=XIL(0xa6864c), vector=XIL(0xa6866d), 
    maxdepth=make_number(10), args_template=make_number(257), nargs=1, 
    args=0x7fffffffd9f0) at bytecode.c:632
#44 0x000000000060877c in funcall_lambda (fun=XIL(0xa6861d), nargs=1, 
    arg_vector=0x7fffffffd9e8) at eval.c:3019
#45 0x0000000000607d8a in Ffuncall (nargs=2, args=0x7fffffffd9e0) at eval.c:2820
#46 0x0000000000607744 in call1 (fn=XIL(0xc480), arg1=XIL(0x11d06665)) at eval.c:2669
#47 0x000000000056763e in timer_check_2 (timers=XIL(0x9cd82a3), 
    idle_timers=XIL(0x9cd82d3)) at keyboard.c:4330
#48 0x000000000056776c in timer_check () at keyboard.c:4392
#49 0x0000000000565989 in readable_events (flags=1) at keyboard.c:3349
#50 0x000000000056bed8 in get_input_pending (flags=1) at keyboard.c:6805
#51 0x00000000005723a2 in detect_input_pending_run_timers (do_display=true)
    at keyboard.c:9943
#52 0x000000000065fb9d in wait_reading_process_output (time_limit=30, nsecs=0, 
    read_kbd=-1, do_display=true, wait_for_cell=XIL(0), wait_proc=0x0, just_wait_proc=0)
    at process.c:5516
#53 0x0000000000425fd4 in sit_for (timeout=make_number(30), reading=true, 
    display_option=1) at dispnew.c:5804
#54 0x00000000005640ac in read_char (commandflag=1, map=XIL(0xb4357a3), 
    prev_event=XIL(0), used_mouse_menu=0x7fffffffe39f, end_time=0x0) at keyboard.c:2723
#55 0x0000000000570b12 in read_key_sequence (keybuf=0x7fffffffe560, bufsize=30, 
    prompt=XIL(0), dont_downcase_last=false, can_return_switch_frame=true, 
    fix_current_buffer=true, prevent_redisplay=false) at keyboard.c:9137
#56 0x0000000000560d38 in command_loop_1 () at keyboard.c:1370
#57 0x00000000006046ce in internal_condition_case (bfun=0x560902 <command_loop_1>, 
    handlers=XIL(0x5280), hfun=0x5600b8 <cmd_error>) at eval.c:1332
#58 0x00000000005605ec in command_loop_2 (ignore=XIL(0)) at keyboard.c:1111
#59 0x0000000000603fa0 in internal_catch (tag=XIL(0xc750), 
    func=0x5605bf <command_loop_2>, arg=XIL(0)) at eval.c:1097
#60 0x000000000056058a in command_loop () at keyboard.c:1090
#61 0x000000000055fc87 in recursive_edit_1 () at keyboard.c:696
#62 0x000000000055fe0b in Frecursive_edit () at keyboard.c:767
#63 0x000000000055da7c in main (argc=1, argv=0x7fffffffea18) at emacs.c:1724

Lisp Backtrace:
"accept-process-output" (0xffff9768)
"network-stream-get-response" (0xffff9c98)
"network-stream-open-starttls" (0xffffa3d8)
"open-network-stream" (0xffffa970)
"nntp-open-connection" (0xffffb090)
"nntp-open-server" (0xffffb5c0)
"nntp-possibly-change-group" (0xffffbec0)
"nntp-with-open-group-function" (0xffffc390)
"nntp-request-article" (0xffffc830)
"gnus-request-article" (0xffffccf0)
"gnus-async-prefetch-article" (0xffffd2a8)
"apply" (0xffffd488)
"timer-event-handler" (0xffffd9e8)


-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 18 Feb 2018 17:58:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Feb 18 12:58:05 2018
Received: from localhost ([127.0.0.1]:50106 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1enTDw-00008b-Iw
	for submit <at> debbugs.gnu.org; Sun, 18 Feb 2018 12:58:04 -0500
Received: from hermes.netfonds.no ([80.91.224.195]:58388)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1enTDu-000089-65
 for 24201 <at> debbugs.gnu.org; Sun, 18 Feb 2018 12:58:03 -0500
Received: from cm-84.209.240.67.getinternet.no ([84.209.240.67] helo=stories)
 by hermes.netfonds.no with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>)
 id 1enTDp-0004D8-Od; Sun, 18 Feb 2018 18:57:59 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#24201: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
 <87efrp2qw0.fsf@mouse> <83tw0lxjt3.fsf@HIDDEN>
Date: Sun, 18 Feb 2018 18:57:57 +0100
In-Reply-To: <83tw0lxjt3.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 02 Sep
 2017 17:21:44 +0300")
Message-ID: <m3r2pikwnu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

OK, I finally found a way to semi-reliably reproduce one of these hangs
I've been seeing.

The symptoms are that I move from one Gnus newsgroup to another, and in
certain circumstances Emacs will then hang forever.  `C-g' does work,
but only after hitting it a number of times -- it varies how many, but
5-10 `C-g's usually allows Emacs to proceed.

I've included the xbacktrace and the backtrace from gdb below.  If I
interpret this correctly, it looks like we're in
wait_reading_process_output, and that code decides to let a timer run,
and the timer then tries to establish a TLS connection, then we'll hang
indefinitely.

I think.

Should I try to run this in an unoptimized build to get more values
filled in?

(gdb) xbacktrace
"accept-process-output" (0xffffb138)
"network-stream-get-response" (0xffffb3d8)
"network-stream-open-starttls" (0xffffb888)
"open-network-stream" (0xffffbb90)
"nntp-open-connection" (0xffffc090)
"nntp-open-server" (0xffffc3a0)
"nntp-possibly-change-group" (0xffffca80)
"nntp-with-open-group-function" (0xffffcd30)
"nntp-request-article" (0xffffcfb0)
"gnus-request-article" (0xffffd250)
"gnus-async-prefetch-article" (0xffffd5e8)
"apply" (0xffffd6f8)
"timer-event-handler" (0xffffd9b8)

#0  pthread_sigmask (how=how@entry=0, newmask=<optimized out>, 
    newmask@entry=0x7fffffffa4f0, oldmask=oldmask@entry=0x7fffffffa590)
    at ../sysdeps/unix/sysv/linux/pthread_sigmask.c:50
#1  0x000000000050b41e in block_interrupt_signal (oldset=oldset@entry=0x7fffffffa590)
    at sysdep.c:843
#2  0x00000000005c821d in really_call_select (arg=0x7fffffffa630) at thread.c:567
#3  0x00000000005c8789 in thread_select (func=<optimized out>, max_fds=max_fds@entry=16, 
    rfds=rfds@entry=0x7fffffffa700, wfds=wfds@entry=0x7fffffffa780, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffad50, sigmask=0x0) at thread.c:602
#4  0x00000000005e5a35 in xg_select (fds_lim=16, rfds=rfds@entry=0x7fffffffae40, 
    wfds=wfds@entry=0x7fffffffaec0, efds=efds@entry=0x0, 
    timeout=timeout@entry=0x7fffffffad50, sigmask=sigmask@entry=0x0) at xgselect.c:117
#5  0x00000000005a9f29 in wait_reading_process_output (time_limit=<optimized out>, 
    nsecs=<optimized out>, read_kbd=read_kbd@entry=0, do_display=do_display@entry=false, 
    wait_for_cell=wait_for_cell@entry=XIL(0), wait_proc=wait_proc@entry=0x40c3ba0, 
    just_wait_proc=0) at process.c:5379
#6  0x00000000005ab808 in Faccept_process_output (process=XIL(0x40c3ba5), 
    seconds=<optimized out>, millisec=<optimized out>, just_this_one=<optimized out>)
    at process.c:4667
#7  0x0000000000568404 in Ffuncall (nargs=<optimized out>, 
    args=args@entry=0x7fffffffb130) at eval.c:2818
#8  0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x4201a65), maxdepth=<optimized out>, args_template=<optimized out>, 
    nargs=nargs@entry=59, args=<optimized out>, args@entry=0x3b) at bytecode.c:632
#9  0x000000000056809f in funcall_lambda (fun=XIL(0x7fffffffb150), nargs=59, 
    nargs@entry=3, arg_vector=0x3b, arg_vector@entry=0x7fffffffb3d8) at eval.c:3019
#10 0x000000000056834b in Ffuncall (nargs=4, args=args@entry=0x7fffffffb3d0)
    at eval.c:2832
#11 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x4201805), maxdepth=<optimized out>, args_template=<optimized out>, 
    nargs=nargs@entry=58, args=<optimized out>, args@entry=0x3a) at bytecode.c:632
#12 0x000000000056809f in funcall_lambda (fun=XIL(0x7fffffffb448), nargs=58, 
    nargs@entry=5, arg_vector=0x3a, arg_vector@entry=0x7fffffffb888) at eval.c:3019
#13 0x000000000056834b in Ffuncall (nargs=6, args=args@entry=0x7fffffffb880)
    at eval.c:2832
#14 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x42014f5), maxdepth=<optimized out>, args_template=<optimized out>, 
    nargs=nargs@entry=56, args=<optimized out>, args@entry=0x38) at bytecode.c:632
#15 0x000000000056809f in funcall_lambda (fun=XIL(0x7fffffffb8d8), nargs=56, 
    nargs@entry=14, arg_vector=0x38, arg_vector@entry=0x7fffffffbb90) at eval.c:3019
#16 0x000000000056834b in Ffuncall (nargs=15, args=args@entry=0x7fffffffbb88)
    at eval.c:2832
#17 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x416a9c5), maxdepth=<optimized out>, 
    args_template=args_template@entry=XIL(0), nargs=nargs@entry=0, args=<optimized out>, 
    args@entry=0x0) at bytecode.c:632
#18 0x0000000000567f69 in funcall_lambda (fun=XIL(0x416ad05), nargs=nargs@entry=1, 
    arg_vector=arg_vector@entry=0x7fffffffc090) at eval.c:3101
#19 0x000000000056834b in Ffuncall (nargs=2, args=args@entry=0x7fffffffc088)
    at eval.c:2832
#20 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x4164515), maxdepth=<optimized out>, 
    args_template=args_template@entry=XIL(0), nargs=nargs@entry=0, args=<optimized out>, 
    args@entry=0x0) at bytecode.c:632
#21 0x0000000000567f69 in funcall_lambda (fun=XIL(0x4161925), nargs=nargs@entry=3, 
    arg_vector=arg_vector@entry=0x7fffffffc3a0) at eval.c:3101
#22 0x000000000056834b in Ffuncall (nargs=4, args=args@entry=0x7fffffffc398)
    at eval.c:2832
#23 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x416b7d5), maxdepth=<optimized out>, 
    args_template=args_template@entry=XIL(0), nargs=nargs@entry=0, args=<optimized out>, 
    args@entry=0x0) at bytecode.c:632
#24 0x0000000000567f69 in funcall_lambda (fun=XIL(0x416bb25), nargs=nargs@entry=3, 
    arg_vector=arg_vector@entry=0x7fffffffca80) at eval.c:3101
#25 0x000000000056834b in Ffuncall (nargs=4, args=args@entry=0x7fffffffca78)
    at eval.c:2832
#26 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x415c965), maxdepth=<optimized out>, 
    args_template=args_template@entry=XIL(0), nargs=nargs@entry=0, args=<optimized out>, 
    args@entry=0x0) at bytecode.c:632
#27 0x0000000000567f69 in funcall_lambda (fun=XIL(0x415ca15), nargs=nargs@entry=4, 
    arg_vector=arg_vector@entry=0x7fffffffcd30) at eval.c:3101
#28 0x000000000056834b in Ffuncall (nargs=5, args=args@entry=0x7fffffffcd28)
    at eval.c:2832
#29 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x4161285), maxdepth=<optimized out>, 
    args_template=args_template@entry=XIL(0), nargs=nargs@entry=0, args=<optimized out>, 
    args@entry=0x0) at bytecode.c:632
#30 0x0000000000567f69 in funcall_lambda (fun=XIL(0x41612b5), nargs=nargs@entry=4, 
    arg_vector=arg_vector@entry=0x7fffffffcfb0) at eval.c:3101
#31 0x000000000056834b in Ffuncall (nargs=5, args=args@entry=0x7fffffffcfa8)
    at eval.c:2832
#32 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x3e57535), maxdepth=<optimized out>, 
    args_template=args_template@entry=XIL(0), nargs=nargs@entry=0, args=<optimized out>, 
    args@entry=0x0) at bytecode.c:632
#33 0x0000000000567f69 in funcall_lambda (fun=XIL(0x3e1d7f5), nargs=nargs@entry=2, 
    arg_vector=arg_vector@entry=0x7fffffffd250) at eval.c:3101
#34 0x000000000056834b in Ffuncall (nargs=3, args=args@entry=0x7fffffffd248)
    at eval.c:2832
#35 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, 
    vector=XIL(0x41b5ba5), maxdepth=<optimized out>, 
    args_template=args_template@entry=XIL(0), nargs=nargs@entry=0, args=<optimized out>, 
    args@entry=0x0) at bytecode.c:632
#36 0x0000000000567f69 in funcall_lambda (fun=XIL(0x424d585), nargs=nargs@entry=3, 
    arg_vector=arg_vector@entry=0x7fffffffd5e8) at eval.c:3101
#37 0x000000000056834b in Ffuncall (nargs=nargs@entry=4, args=0x7fffffffd5e0)
    at eval.c:2832
#38 0x0000000000569d70 in Fapply (nargs=2, args=<optimized out>) at eval.c:2438
#39 0x0000000000568404 in Ffuncall (nargs=<optimized out>, 
    args=args@entry=0x7fffffffd6f0) at eval.c:2818
#40 0x000000000059eea8 in exec_byte_code (bytestr=<optimized out>, vector=XIL(0x99b3dd), 
    maxdepth=<optimized out>, args_template=<optimized out>, nargs=nargs@entry=6, 
    args=<optimized out>, args@entry=0x6) at bytecode.c:632
#41 0x000000000056809f in funcall_lambda (fun=XIL(0x7fffffffd728), nargs=6, 
    nargs@entry=1, arg_vector=0x6, arg_vector@entry=0x7fffffffd9b8) at eval.c:3019
#42 0x000000000056834b in Ffuncall (nargs=nargs@entry=2, args=args@entry=0x7fffffffd9b0)
    at eval.c:2832
#43 0x00000000005684ba in call1 (fn=fn@entry=XIL(0xc480), arg1=arg1@entry=XIL(0x4b72725))
    at eval.c:2669
#44 0x00000000004f8ebb in timer_check_2 (idle_timers=<optimized out>, 
    timers=<optimized out>) at keyboard.c:4330
#45 timer_check () at keyboard.c:4392
#46 0x00000000005a9367 in wait_reading_process_output (time_limit=time_limit@entry=30, 
    nsecs=nsecs@entry=0, read_kbd=-1, do_display=do_display@entry=true, 
    wait_for_cell=wait_for_cell@entry=XIL(0), wait_proc=wait_proc@entry=0x0, 
    just_wait_proc=0) at process.c:5144
#47 0x0000000000424060 in sit_for (timeout=<optimized out>, reading=reading@entry=true, 
    display_option=display_option@entry=1) at dispnew.c:5804
#48 0x00000000004feae2 in read_char (commandflag=commandflag@entry=1, 
    map=map@entry=XIL(0x4dca1c3), prev_event=<optimized out>, 
    used_mouse_menu=used_mouse_menu@entry=0x7fffffffe5ab, end_time=end_time@entry=0x0)
    at keyboard.c:2723
#49 0x00000000004ff7b7 in read_key_sequence (keybuf=keybuf@entry=0x7fffffffe6a0, 
    prompt=prompt@entry=XIL(0), dont_downcase_last=dont_downcase_last@entry=false, 
    can_return_switch_frame=can_return_switch_frame@entry=true, 
    fix_current_buffer=fix_current_buffer@entry=true, 
    prevent_redisplay=prevent_redisplay@entry=false, bufsize=30) at keyboard.c:9137
#50 0x00000000005013be in command_loop_1 () at keyboard.c:1370
#51 0x00000000005669ae in internal_condition_case (
    bfun=bfun@entry=0x5011a0 <command_loop_1>, handlers=handlers@entry=XIL(0x5280), 
    hfun=hfun@entry=0x4f8210 <cmd_error>) at eval.c:1332
#52 0x00000000004f2b94 in command_loop_2 (ignore=ignore@entry=XIL(0)) at keyboard.c:1111
#53 0x000000000056694c in internal_catch (tag=tag@entry=XIL(0xc750), 
    func=func@entry=0x4f2b70 <command_loop_2>, arg=arg@entry=XIL(0)) at eval.c:1097
#54 0x00000000004f2b50 in command_loop () at keyboard.c:1090
#55 0x00000000004f7df3 in recursive_edit_1 () at keyboard.c:696
#56 0x00000000004f8158 in Frecursive_edit () at keyboard.c:767
#57 0x000000000041a5c3 in main (argc=<optimized out>, argv=0x7fffffffea18)
    at emacs.c:1724

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.
Removed indication that bug 24201 blocks Request was from Eli Zaretskii <eliz@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 2 Sep 2017 14:22:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 02 10:22:25 2017
Received: from localhost ([127.0.0.1]:43556 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1do9JW-0005TL-5h
	for submit <at> debbugs.gnu.org; Sat, 02 Sep 2017 10:22:25 -0400
Received: from eggs.gnu.org ([208.118.235.92]:34122)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1do9JU-0005T8-66
 for 24201 <at> debbugs.gnu.org; Sat, 02 Sep 2017 10:22:20 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1do9JK-0000aK-F2
 for 24201 <at> debbugs.gnu.org; Sat, 02 Sep 2017 10:22:15 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:50771)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1do9J4-0000Qa-2T; Sat, 02 Sep 2017 10:21:54 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2298
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1do9J3-0001x7-G1; Sat, 02 Sep 2017 10:21:53 -0400
Date: Sat, 02 Sep 2017 17:21:44 +0300
Message-Id: <83tw0lxjt3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87efrp2qw0.fsf@mouse> (message from Lars Ingebrigtsen on Sat, 02
 Sep 2017 15:04:31 +0200)
Subject: Re: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN> <87efrp2qw0.fsf@mouse>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

unblock 24655 by 24201
thanks

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org,  eggert@HIDDEN
> Date: Sat, 02 Sep 2017 15:04:31 +0200
> 
> > Any news on this one?  It's been almost a year since the last
> > communication about this issue; if we still have the problem, why is
> > no one else seeing it?
> 
> I still haven't found time to debug it, but I see the hangs daily (on
> builds on different machines).  I'd guess few other people see this
> because they don't use the network as intensely from Emacs (you need to
> have two TLS connections being set up "simultaneously" to see the hang).
> 
> But I don't think this should be a release blocker, precisely because so
> few people see the bug.

OK, I'm unblocking Emacs 26.1 due to this.

Hopefully, you will find tome to debug this at some point.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 2 Sep 2017 13:04:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 02 09:04:47 2017
Received: from localhost ([127.0.0.1]:41788 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1do86N-0002ED-Ol
	for submit <at> debbugs.gnu.org; Sat, 02 Sep 2017 09:04:47 -0400
Received: from hermes.netfonds.no ([80.91.224.195]:55230)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1do86I-0002E1-QQ
 for 24201 <at> debbugs.gnu.org; Sat, 02 Sep 2017 09:04:42 -0400
Received: from cm-84.209.243.26.getinternet.no ([84.209.243.26] helo=mouse)
 by hermes.netfonds.no with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.84_2) (envelope-from <larsi@HIDDEN>)
 id 1do86B-00007l-8q; Sat, 02 Sep 2017 15:04:37 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
 <83d1j8e9c0.fsf@HIDDEN> <83shg5z32d.fsf@HIDDEN>
Date: Sat, 02 Sep 2017 15:04:31 +0200
In-Reply-To: <83shg5z32d.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 02 Sep
 2017 15:40:26 +0300")
Message-ID: <87efrp2qw0.fsf@mouse>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

>> Date: Mon, 10 Oct 2016 14:23:43 +0300
>> From: Eli Zaretskii <eliz@HIDDEN>
>> Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
>> 
>> > From: Lars Ingebrigtsen <larsi@HIDDEN>
>> > Cc: Paul Eggert <eggert@HIDDEN>,  24201 <at> debbugs.gnu.org
>> > Date: Mon, 10 Oct 2016 12:54:36 +0200
>> > 
>> > Eli Zaretskii <eliz@HIDDEN> writes:
>> > 
>> > > Should this bug be closed?  Lars, do you still see the problem, and if
>> > > you do, on what branch?
>> > 
>> > I still see this problem, and it's on the master branch.
>> 
>> OK, thanks.  I moved the bug to block the release of 26.1, which will
>> be the first version released from what is now master.
>
> Any news on this one?  It's been almost a year since the last
> communication about this issue; if we still have the problem, why is
> no one else seeing it?

I still haven't found time to debug it, but I see the hangs daily (on
builds on different machines).  I'd guess few other people see this
because they don't use the network as intensely from Emacs (you need to
have two TLS connections being set up "simultaneously" to see the hang).

But I don't think this should be a release blocker, precisely because so
few people see the bug.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 2 Sep 2017 12:41:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 02 08:41:03 2017
Received: from localhost ([127.0.0.1]:41733 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1do7jQ-0006NX-Do
	for submit <at> debbugs.gnu.org; Sat, 02 Sep 2017 08:41:03 -0400
Received: from eggs.gnu.org ([208.118.235.92]:57160)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1do7jL-0006NE-8k
 for 24201 <at> debbugs.gnu.org; Sat, 02 Sep 2017 08:40:58 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1do7jB-00089x-NZ
 for 24201 <at> debbugs.gnu.org; Sat, 02 Sep 2017 08:40:50 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:48141)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1do7j2-0007tr-Da; Sat, 02 Sep 2017 08:40:36 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2058
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1do7j1-0000Cc-Ri; Sat, 02 Sep 2017 08:40:36 -0400
Date: Sat, 02 Sep 2017 15:40:26 +0300
Message-Id: <83shg5z32d.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: larsi@HIDDEN
In-reply-to: <83d1j8e9c0.fsf@HIDDEN> (message from Eli Zaretskii on Mon, 10
 Oct 2016 14:23:43 +0300)
Subject: Re: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN> <83d1j8e9c0.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> Date: Mon, 10 Oct 2016 14:23:43 +0300
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
> 
> > From: Lars Ingebrigtsen <larsi@HIDDEN>
> > Cc: Paul Eggert <eggert@HIDDEN>,  24201 <at> debbugs.gnu.org
> > Date: Mon, 10 Oct 2016 12:54:36 +0200
> > 
> > Eli Zaretskii <eliz@HIDDEN> writes:
> > 
> > > Should this bug be closed?  Lars, do you still see the problem, and if
> > > you do, on what branch?
> > 
> > I still see this problem, and it's on the master branch.
> 
> OK, thanks.  I moved the bug to block the release of 26.1, which will
> be the first version released from what is now master.

Any news on this one?  It's been almost a year since the last
communication about this issue; if we still have the problem, why is
no one else seeing it?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 10 Oct 2016 11:23:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 07:23:45 2016
Received: from localhost ([127.0.0.1]:50567 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1btYgK-0003UY-UU
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2016 07:23:45 -0400
Received: from eggs.gnu.org ([208.118.235.92]:36057)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1btYgH-0003Tu-AN
 for 24201 <at> debbugs.gnu.org; Mon, 10 Oct 2016 07:23:44 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1btYg7-0000s6-Hx
 for 24201 <at> debbugs.gnu.org; Mon, 10 Oct 2016 07:23:36 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.2 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:47361)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1btYg7-0000rg-Fc; Mon, 10 Oct 2016 07:23:31 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:3449
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1btYg5-00033C-JY; Mon, 10 Oct 2016 07:23:30 -0400
Date: Mon, 10 Oct 2016 14:23:43 +0300
Message-Id: <83d1j8e9c0.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <m3pon8lbir.fsf@HIDDEN> (message from Lars Ingebrigtsen on Mon, 
 10 Oct 2016 12:54:36 +0200)
Subject: Re: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN> <m3pon8lbir.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.3 (-----)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, eggert@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.3 (-----)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Paul Eggert <eggert@HIDDEN>,  24201 <at> debbugs.gnu.org
> Date: Mon, 10 Oct 2016 12:54:36 +0200
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Should this bug be closed?  Lars, do you still see the problem, and if
> > you do, on what branch?
> 
> I still see this problem, and it's on the master branch.

OK, thanks.  I moved the bug to block the release of 26.1, which will
be the first version released from what is now master.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.
Added indication that bug 24201 blocks24655 Request was from Eli Zaretskii <eliz@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Removed indication that bug 24201 blocks Request was from Eli Zaretskii <eliz@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 10 Oct 2016 10:56:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 06:56:51 2016
Received: from localhost ([127.0.0.1]:50541 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1btYGJ-0002mb-4I
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2016 06:56:51 -0400
Received: from hermes.netfonds.no ([80.91.224.195]:58925)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1btYGG-0002mR-NB
 for 24201 <at> debbugs.gnu.org; Mon, 10 Oct 2016 06:56:49 -0400
Received: from cm-84.215.1.64.getinternet.no ([84.215.1.64] helo=stories)
 by hermes.netfonds.no with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.84_2) (envelope-from <larsi@HIDDEN>)
 id 1btYG6-0001XI-2p; Mon, 10 Oct 2016 12:56:40 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
 <83mvicebin.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAFVBMVEVBQD+DgHwHBgjIwrob
 ERMCAgTv6d6PdrwkAAACc0lEQVQ4jVWUwW4jIQyGzcTZM5Q255Yy96FUnCcsuVejcm+ExPs/wv5m
 km6LFBT5w/ZvY4bcWL5k92t5cjN2N28/bCz7AL9XWfMArrrtp91PzzewjfBe9jKA/C0AYpn9sBWW
 E3738CyKigCX1+kGoOqZmL0HQE6/Ut5DwYOIif1aykpciKZvwLCspIhI6cL/AYLAZoyxMUa4ZHdL
 /lwcKdhjx7oyidxpAHYr3ey9B3YzQydnOjOK0SbtoD1IdOjJpBhZWN1Af3KOyaOtpBSXUr7Bw+ym
 0SJSwYLYfvfYZoZ6lHfQZinrcGji4dyECCL1sEStYI1RKJROo/t0jtoGRAooE5qn+Q7+NkoBloXs
 olI81jt47QFhULSyfO76WLfjDl56S03Ca/aH1i7VwWm0JKU48l7zmq7XWuulbqO7trUepVUh9a+p
 1u2y7eNjYgDYm9iexEMGB8AGlW5FoHDxmOvw+LMceo/oe0sDYG130FqwqUu0490+gN1l9S91QuK5
 rDK8xKcY7J67GV2rjJDm7Kj0hKL31Al1bx7TQioTOn4lk2JqxgioGBlMxyMZhGCFLBHnUPQngLZG
 k8Sm1UZjQ1zmWj9wHBexDKCLDFA0C7QqmTJrFkoCuCAYZgfA4IyKd0C8ysihvI8AcIjmXa5TQFYY
 XqR4CWp4vJP0QlPJn5CPSAcBJgAoAaXMNfuL5NZGRIV3KB3J5/op/cOAi6gY3qjQCSDLPeDnVwaI
 xrxRLtYQHOSua/UkIBn7RlNReJESxstV4EEq2018IHZ8fhTgBKBTBKFXAO15fXR13jDIN0Cna8yk
 8fzxKDK+CvLuV3m8pxboH68J0n05UujOAAAAAElFTkSuQmCC
Date: Mon, 10 Oct 2016 12:54:36 +0200
In-Reply-To: <83mvicebin.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 10 Oct
 2016 13:36:32 +0300")
Message-ID: <m3pon8lbir.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org, Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

> Should this bug be closed?  Lars, do you still see the problem, and if
> you do, on what branch?

I still see this problem, and it's on the master branch.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 10 Oct 2016 10:36:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 06:36:31 2016
Received: from localhost ([127.0.0.1]:50521 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1btXwd-0000ex-EI
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2016 06:36:31 -0400
Received: from eggs.gnu.org ([208.118.235.92]:53643)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1btXwc-0000ek-8W
 for 24201 <at> debbugs.gnu.org; Mon, 10 Oct 2016 06:36:30 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1btXwS-0002ax-N5
 for 24201 <at> debbugs.gnu.org; Mon, 10 Oct 2016 06:36:25 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.2 required=5.0 tests=BAYES_00,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:46760)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1btXwS-0002aQ-GP; Mon, 10 Oct 2016 06:36:20 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:3022
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1btXwQ-0008Up-KY; Mon, 10 Oct 2016 06:36:19 -0400
Date: Mon, 10 Oct 2016 13:36:32 +0300
Message-Id: <83mvicebin.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Paul Eggert <eggert@HIDDEN>
In-reply-to: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN> (message from
 Paul Eggert on Sun, 14 Aug 2016 19:35:45 -0700)
Subject: Re: 25.1.50; TLS connections sometimes hang
References: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -7.7 (-------)
X-Debbugs-Envelope-To: 24201
Cc: larsi@HIDDEN, 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -7.7 (-------)

> From: Paul Eggert <eggert@HIDDEN>
> Date: Sun, 14 Aug 2016 19:35:45 -0700
> Cc: 24201 <at> debbugs.gnu.org
> 
> > A couple of weeks ago, TLS connections started making Emacs hang.
> 
> I installed several changes on August 3. They were in the area of nonblocking 
> GnuTLS connections (Bug#23982) and perhaps could explain your problem. See the 
> following commits:
> 
> 967e2ef61dab8d2046f3285eefa71f3dcb9d9b60
> f0b5d4bd3e17bc0a464b9ec69507413824568f9e
> 744cc9fa17d20450fc3cf1ca6bb71869abeeb77b
> 1a8d31123698ccf6f165e49fcfe16631d07a7aea
> 64edd14ca9cf6d1b957316a9a547e482c9ba811b
> 
> On August 2 I also installed a fix for a use-after-close problem that could be 
> relevant. See:
> 
> 53917616b0aca43b9ca85531d4dcb426885bdb73
> a066fb1ceee373c982214c28206108c5fba01bf7

Should this bug be closed?  Lars, do you still see the problem, and if
you do, on what branch?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.

Message received at 24201 <at> debbugs.gnu.org:


Received: (at 24201) by debbugs.gnu.org; 15 Aug 2016 02:35:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Aug 14 22:35:53 2016
Received: from localhost ([127.0.0.1]:57755 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bZ7km-0003pi-VY
	for submit <at> debbugs.gnu.org; Sun, 14 Aug 2016 22:35:53 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:44390)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1bZ7kl-0003pX-T4
 for 24201 <at> debbugs.gnu.org; Sun, 14 Aug 2016 22:35:52 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 53EA4160D3D;
 Sun, 14 Aug 2016 19:35:46 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id JhdvDxNiCu2L; Sun, 14 Aug 2016 19:35:45 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id A6B60160E3A;
 Sun, 14 Aug 2016 19:35:45 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id RkU3u5oBYqzU; Sun, 14 Aug 2016 19:35:45 -0700 (PDT)
Received: from [192.168.1.9] (unknown [100.32.155.148])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 8984D160D3D;
 Sun, 14 Aug 2016 19:35:45 -0700 (PDT)
To: Lars Ingebrigtsen <larsi@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Subject: Re: 25.1.50; TLS connections sometimes hang
Organization: UCLA Computer Science Department
Message-ID: <b74e44ab-f1e4-46d9-62e9-bce43773946c@HIDDEN>
Date: Sun, 14 Aug 2016 19:35:45 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:45.0) Gecko/20100101
 Thunderbird/45.2.0
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 24201
Cc: 24201 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

> A couple of weeks ago, TLS connections started making Emacs hang.

I installed several changes on August 3. They were in the area of nonbloc=
king=20
GnuTLS connections (Bug#23982) and perhaps could explain your problem. Se=
e the=20
following commits:

967e2ef61dab8d2046f3285eefa71f3dcb9d9b60
f0b5d4bd3e17bc0a464b9ec69507413824568f9e
744cc9fa17d20450fc3cf1ca6bb71869abeeb77b
1a8d31123698ccf6f165e49fcfe16631d07a7aea
64edd14ca9cf6d1b957316a9a547e482c9ba811b

On August 2 I also installed a fix for a use-after-close problem that cou=
ld be=20
relevant. See:

53917616b0aca43b9ca85531d4dcb426885bdb73
a066fb1ceee373c982214c28206108c5fba01bf7




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.
Added indication that bug 24201 blocks21966 Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 11 Aug 2016 13:21:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Aug 11 09:21:18 2016
Received: from localhost ([127.0.0.1]:53184 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bXpvC-0006e2-Bv
	for submit <at> debbugs.gnu.org; Thu, 11 Aug 2016 09:21:18 -0400
Received: from eggs.gnu.org ([208.118.235.92]:36301)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1bXpvB-0006dn-AZ
 for submit <at> debbugs.gnu.org; Thu, 11 Aug 2016 09:21:17 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <larsi@HIDDEN>) id 1bXpv4-000120-JH
 for submit <at> debbugs.gnu.org; Thu, 11 Aug 2016 09:21:12 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:49187)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <larsi@HIDDEN>) id 1bXpv4-00011r-GT
 for submit <at> debbugs.gnu.org; Thu, 11 Aug 2016 09:21:10 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:55468)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <larsi@HIDDEN>) id 1bXpv2-0003Eu-CG
 for bug-gnu-emacs@HIDDEN; Thu, 11 Aug 2016 09:21:10 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <larsi@HIDDEN>) id 1bXpuz-0000yI-3s
 for bug-gnu-emacs@HIDDEN; Thu, 11 Aug 2016 09:21:08 -0400
Received: from hermes.netfonds.no ([80.91.224.195]:55268)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <larsi@HIDDEN>) id 1bXpuy-0000wU-PC
 for bug-gnu-emacs@HIDDEN; Thu, 11 Aug 2016 09:21:05 -0400
Received: from cm-84.215.1.64.getinternet.no ([84.215.1.64] helo=stories)
 by hermes.netfonds.no with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.84_2) (envelope-from <larsi@HIDDEN>) id 1bXpur-0002Rc-Ld
 for bug-gnu-emacs@HIDDEN; Thu, 11 Aug 2016 15:21:01 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 25.1.50; TLS connections sometimes hang
Date: Thu, 11 Aug 2016 15:20:18 +0200
Message-ID: <m3wpjnigrx.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)


A couple of weeks ago, TLS connections started making Emacs hang.  I've
yet to find a way to reproduce it reliably, but it seems to involve
opening an async TLS connection while opening a synchronous TLS
connection, or something.

strace in these instances shows an infinite loop like this:

[pid 28250] pselect6(27, [4 6 8 9 10 14 15 16 17 18 19 20 22 24 26], [], NULL, {0, 0}, {NULL, 8}) = 1 (in [20], left {0, 0})
[pid 28250] pselect6(27, [4 6 8 9 10 14 15 16 17 18 19 20 22 24 26], [], NULL, {0, 0}, {NULL, 8}) = 1 (in [20], left {0, 0})
[pid 28250] pselect6(27, [4 6 8 9 10 14 15 16 17 18 19 20 22 24 26], [], NULL, {0, 0}, {NULL, 8}) = 1 (in [20], left {0, 0})
[pid 28250] pselect6(27, [4 6 8 9 10 14 15 16 17 18 19 20 22 24 26], [], NULL, {0, 0}, {NULL, 8}) = 1 (in [20], left {0, 0})

Does this ring a bell?  If not, I'll try to debug it further.

I think it started happening like two or three weeks ago.


In GNU Emacs 25.1.50.2 (x86_64-unknown-linux-gnu, GTK+ Version 3.14.5)
 of 2016-07-20 built on stories
Repository revision: 60dd094a8c7bdbbff121c99f56f42910534e7cc1
Windowing system distributor 'The X.Org Foundation', version 11.0.11604000
System Description:	Debian GNU/Linux 8.5 (jessie)

Recent messages:
Quit opening connection to news.gmane.org
Quit [2 times]
Mark set
Opening nntp server on news.gmane.org...done
Mark set
Opening nntp server on news.gmane.org...done
Quit
Quit opening connection to news.gmane.org
Quit
Making completion list...

Configured features:
XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK SOUND GPM DBUS GCONF GSETTINGS
NOTIFY ACL LIBSELINUX GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB
TOOLKIT_SCROLL_BARS GTK3 X11

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Group

Minor modes in effect:
  gnus-agent-group-mode: t
  shell-dirtrack-mode: t
  diff-auto-refine-mode: t
  gnus-topic-mode: t
  gnus-undo-mode: t
  global-whitespace-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  buffer-read-only: t
  line-number-mode: t

Load-path shadows:
/home/larsi/src/cddb.el/expect hides /home/larsi/lisp/expect
/home/larsi/src/cddb.el/captitle hides /home/larsi/lisp/captitle
/home/larsi/src/clock.el/clock hides /home/larsi/lisp/clock
~/pgnus/contrib/vcard hides /home/larsi/lisp/vcard
/home/larsi/src/pvr.el/pvr hides /home/larsi/lisp/pvr
~/lisp/zenirc-2.112/src/zenirc-example hides /home/larsi/lisp/zenirc-example
~/pgnus/contrib/compface hides /home/larsi/src/emacs/trunk/lisp/image/compface

Features:
(shadow emacsbug perl-mode org-element org-rmail org-mhe org-irc
org-info org-gnus org-docview org-bibtex bibtex org-bbdb org-w3m org
org-macro org-footnote org-pcomplete org-list org-faces org-entities
org-version ob-emacs-lisp ob ob-tangle ob-ref ob-lob ob-table ob-exp
org-src ob-keys ob-comint ob-core ob-eval org-compat org-macs
org-loaddefs cal-menu calendar cal-loaddefs ffap tabify imenu man
sh-script smie executable imap cc-mode cc-fonts cc-guess cc-menus
cc-cmds cc-styles cc-align cc-engine cc-vars cc-defs smerge-mode crm
macros eieio-opt speedbar sb-image ezimage dframe etags texinfo
conf-mode nndir nnspool dired-aux grep compile vc-bzr vc-src vc-sccs
vc-svn vc-rcs vc-dir ewoc bug-reference noutline outline edebug log-edit
previews json shell pcomplete comint canlock flow-fill vc-annotate
log-view pcvs-util vc vc-dispatcher eww pp vc-git diff-mode map pulse
find-func thingatpt xref project ring misearch multi-isearch mailalias
smtpmail sendmail ecomplete copyright vc-cvs shr-color color gnus-html
help-fns radix-tree sort gnus-cite smiley ansi-color url-queue url-cache
mm-archive gnus-async gnus-dup qp gnus-ml gmane spam-gmane dns mm-url
disp-table gnus-fun gnus-mdrtn pop3 nndoc nnmbox utf-7 gnus-topic nnml
nnfolder network-stream starttls nnir spam-report spam spam-stat gnus-uu
yenc gnus-delay gnus-draft gnus-agent gnus-srvr gnus-score score-mode
nnvirtual nntp gnus-cache gnus-msg gnus-art mm-uu mml2015 mm-view
mml-smime smime dig gnus-sum nndraft nnmh gnus-group gnus-undo
gnus-start gnus-cloud nnimap utf7 netrc nnoo parse-time gnus-spec
gnus-win nnmail gnus-int gnus-range mail-source message format-spec
rfc822 mml mml-sec epa epg mailabbrev gmm-utils mailheader gnus nnheader
gnus-util rmail rmail-loaddefs mail-utils whitespace movie mkv shr svg
imdb dom pvr debug debbugs-gnu easy-mmode derived debbugs soap-client
mm-decode mm-bodies mm-encode url-http tls gnutls url-auth mail-parse
rfc2231 rfc2047 rfc2045 mm-util ietf-drums mail-prsvr url-gw nsm puny
url url-proxy url-privacy url-expand url-methods url-history url-cookie
url-domsuf url-util mailcap warnings rng-xsd rng-dt rng-util xsd-regexp
xml ido flyspell ispell benchmark w3m browse-url doc-view subr-x dired
dired-loaddefs image-mode timezone w3m-hist w3m-fb w3m-ems wid-edit
w3m-ccl ccl w3m-favicon w3m-image w3m-proc w3m-util add-log mail-extr
jka-compr cl finder-inf package epg-config url-handlers url-parse
auth-source cl-seq eieio eieio-core cl-macs eieio-loaddefs
password-cache url-vars seq byte-opt gv bytecomp byte-compile cl-extra
help-mode easymenu cconv cl-loaddefs pcase cl-lib time-date mule-util
tooltip eldoc electric uniquify ediff-hook vc-hooks lisp-float-type
mwheel term/x-win x-win term/common-win x-dnd tool-bar dnd fontset image
regexp-opt fringe tabulated-list newcomment elisp-mode lisp-mode
prog-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax facemenu font-core term/tty-colors frame
cl-generic cham georgian utf-8-lang misc-lang vietnamese tibetan thai
tai-viet lao korean japanese eucjp-ms cp51932 hebrew greek romanian
slovak czech european ethiopic indian cyrillic chinese charscript
case-table epa-hook jka-cmpr-hook help simple abbrev obarray minibuffer
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote dbusbind inotify
dynamic-setting system-font-setting font-render-setting move-toolbar gtk
x-toolkit x multi-tty make-network-process emacs)

Memory information:
((conses 16 3259686 974810)
 (symbols 48 216414 408)
 (miscs 40 3192 5495)
 (strings 32 609506 170950)
 (string-bytes 1 57242968)
 (vectors 16 95117)
 (vector-slots 8 2432568 99890)
 (floats 8 10530 14727)
 (intervals 56 472696 10642)
 (buffers 976 311)
 (heap 1024 591462 804639))

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no





Acknowledgement sent to Lars Ingebrigtsen <larsi@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#24201; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 3 Aug 2020 06:15:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.